#include <stdio.h>
#include <xview/xview.h>
#include "tool.h"
#include "g.h"
#include "state.h"
#include "ext.h"
#include "extxv.h"

create_arc (sx, sy, rx, ry, dx, dy, arcno, dststate, srcstate)
int sx,sy,rx,ry,dx,dy,arcno;
struct g_node *dststate, *srcstate;
{
	point s,r,d,p;
	struct g_link *link;
	struct g_rspt *rspt;
	struct g_label *label;
	Font_string_dims dims;
	int i;

	link = (struct g_link *) malloc(G_LINK_SIZE);
	rspt = (struct g_rspt *) malloc(G_RSPT_SIZE);
	label = (struct g_label *) malloc(G_LABEL_SIZE);
	link->no = ++(g->link_no);
	rspt->no = ++(g->rspt_no);
	label->no = ++(g->label_no);
	modified();
	s.x = sx;  s.y = sy;
	r.x = rx;  r.y = ry;
	d.x = dx;  d.y = dy;
	/* find_port(r,s, &p); */
	link->arcno = arcno;
	link->src_port.x = s.x; /* use p.x in old version 
				   if use s.x then find_port is not necessary*/
	link->src_port.y = s.y + 32;

	link->src_port.node = srcstate;
	draw_vector(s.x, s.y+32, rx, ry); /* use p.x in old version */
	link->label = label;
	i = strlen(arc[arcno].label) + 1;
	label->name = (char *) malloc(i*sizeof(char));
	strcpy(label->name, arc[arcno].label);
	(void) xv_get(font, FONT_STRING_DIMS, label->name, &dims);
	label->w = dims.width;
	label->h = dims.height;
	label->link = link;
	label->next = (struct g_label *) 0;
	label->x = r.x - (label->w)/2.0;
	label->y = r.y - 2;
	rspt->x = r.x;
	rspt->y = r.y;
	rspt->link = link;
	rspt->next_inlink = (struct g_rspt *) 0;
	rspt->next = (struct g_rspt *) 0;
	/* find_port(r,d, &p); */
	link->dst_port.x = d.x; /* use p.x in old version */
	link->dst_port.y = d.y - 32;
	link->dst_port.node = dststate;
	draw_vector(r.x, r.y, d.x, d.y- 32); /* use p.x in old versoin */
	write_edge_label(label);
	link->rest_points = rspt;
	link->inlink = dststate->inlink;
	dststate->inlink = link;
	link->outlink = srcstate->outlink;
	srcstate->outlink = link;
	link->next =  (struct g_link *) 0;

	insert_rspt(rspt);
	insert_label(label);
	insert_link(link);
}

draw_state(lst, x, y)
struct STATELST *lst;
int x, y;
{
	register int ssno;

	put_node(lst, x, y);
	write_state(lst->ssno, x, y);
}

struct g_node *
search_node(g, node_id)
struct GRAPH *g;
int node_id;
{	
	struct g_node *node;

	for (node = g->first_node; node != 0; node = node->next) 
		if (node->no == node_id) return(node);
	return(0);
}

write_state(ssn, x, y)
int ssn, x, y;
{
	int ssno;
	struct g_node *node;

	if (ssn < 0) write_ssprop("*", x + 9, y -20);
	ssno = abs(ssn);
	if (ssno == 99999) ssno = 0;
	write_ssno(ssno, x - 28, y - 19);
	write_ssprop(ss[ssno].property, x + 17, y - 20);
	node = search_node(P[1].g, ss[ssno].pn[1]);
	write_P(node->label, x - 28, y + 8);
	node = search_node(P[0].g, ss[ssno].pn[0]);
	write_P(node->label, x + 15, y + 8);
	write_C(ss[ssno].c[1].m, x , y - 7);
	write_C(ss[ssno].c[0].m, x , y + 25);
}

put_node(lst, x, y)
struct STATELST *lst;
int x, y;
{
	struct g_node	*node;
	int ssn;

	node = (struct g_node *) malloc(G_NODE_SIZE);
	node->no = ++(g->node_no);
	node->x = x;
	node->y = y;
	node->label = 0;
	node->ssno = lst->ssno;
	node->inlink = (struct g_link *) 0;
	node->outlink = (struct g_link *) 0;
	node->next = (struct g_node *) 0;
	draw_node(x, y);
	insert_node(node);
	lst->node = node;
}

write_ssno(ssno, x, y)
int ssno, x, y;
{
	char str[5];

	sprintf(str, "%d", ssno);
	pwtext((x + DX)/zoom, (y + DY)/zoom, str);
}

write_ssprop(p, x, y)
char p[];
int  x, y;
{
	char str[2];

	if (strlen(p) != 0) {
	   str[0] = p[0];
	   str[1] = (char) 0;
	   pwtext((x + DX)/zoom, (y + DY)/zoom, str);
	   }
}

write_P(p, x, y)
char p[];
int  x, y;
{
	if (strlen(p) == 1) x += 4;
	pwtext((x + DX)/zoom, (y + DY)/zoom, p);
}

write_C(c, x, y)
char c[];
int  x, y;
{
	char str[6];

	if (strlen(c) > 5) {
	   x -= 15;
	   y -= 4;
	   strncpy(str, c, 5);
	   pwtext((x + DX)/zoom, (y + DY)/zoom, str);
	   y += 8;
	   pwtext((x + DX)/zoom, (y + DY)/zoom, &(c[5]));
	   }
	else {
	   x -= 3 * strlen(c);
	   pwtext((x + DX)/zoom, (y + DY)/zoom, c);
	   }
}

draw_state_list(lst, depth)
struct STATELST *lst;
int depth;
{
	register int i, y, x;
	struct STATELST *l;

	if (lst == 0) return;
	for (l = lst, i = 0; l != 0; l = l->next, i++);
	y =  depth * 110;
	x = 0 - (i - 1) * ((i > 8) ? 35 : 40);
	for (; lst != 0; lst = lst->next, x += ((i > 8) ? 70 : 80))
	    draw_state(lst, x, y);
}

draw_arc_list(outarclst, depth, srclst, dstlst)
struct ARCLST *outarclst;
struct STATELST *srclst, *dstlst;
int depth;
{
	register int 	sn, dn;
	struct g_node	*srcstate, *dststate;
	struct ARCLST 	*al;
	struct STATELST *sl;
	int 		i, d, sx, sy, dx, dy, rx, ry;

	for (al = outarclst, i = 0; al != 0; al = al->next, i++); 
	ry = 55 + (depth - 1) * 110;
	if (i > 4) d = 25;
	else       d = 40;
	rx = 0 - (i - 1) * d;
	for (al = outarclst; al != 0; al = al->next, rx += d + d) {
	    sn = arc[al->arcno].srcssno;
	    dn = arc[al->arcno].dstssno;
	    /* find the node represents the state sn */
	    for (sl = srclst; abs(sl->ssno) != abs(sn); sl = sl->next);
	    sx = sl->node->x;
	    sy = sl->node->y;
	    srcstate = sl->node;
	    for (sl = dstlst; abs(sl->ssno) != abs(dn); sl = sl->next);
	    dx = sl->node->x;
	    dy = sl->node->y;
	    dststate = sl->node;
	    create_arc(sx, sy, rx, ry, dx, dy, al->arcno, dststate, srcstate);
	    }
}

