#include <stdio.h>
#include <xview/tool_hs.h>
#include <xview/menu.h>
#include <xview/notice.h>
#include "tool.h"
#include "menu.h"
#include "g.h"
#include "state.h"
#include "ext.h"


void
PLACE_NODE_proc(item, event)
Menu_item item;
Event *event;
{
	mode = PLACE_NODE;
	put_text_high("Hit left button for new node; correct position by moving mouse;");
	put_text(" hit left button again to confirm position; middle button : cancel.");
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, node_cursor, NULL);
}

void
MOVE_NODE_proc(item, event)
Menu_item item;
Event *event;
{
	mode = MOVE_NODE;
	put_text("Please point to the node to be moved .");
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, node_cursor, NULL);
}

void
REMOVE_NODE_proc(item, event)
Menu_item item;
Event *event;
{
	mode = REMOVE_NODE;
	put_text("Please point to the node to be removed .");
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, node_cursor, NULL);
}

void
CHANGE_NODE_LABEL_proc(item, event)
Menu_item item;
Event *event;
{
	mode = CHANGE_NODE_LABEL;
	put_text("Please point to the node label to be changed.");
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, node_cursor, NULL);
}

void
CHANGE_INITIAL_NODE_proc(item, event)
Menu_item item;
Event *event;
{
	mode = CHANGE_INITIAL_NODE;
	put_text("Please point to the new initial node.");
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, node_cursor, NULL);
}

void
PLACE_LINK_proc(item, event)
Menu_item item;
Event *event;
{
	mode = PLACE_LINK;
	link_type = T_SPLINE; /* default */
	channel_type = UNI_DIRECTIONAL; /* default */
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, link_cursor, NULL);
	put_text("Please select the link type of the edge in the middle button menu.");
	menu_selected = menu2_selected;
}

void
MOVE_LINK_proc(item, event)
Menu_item item;
Event *event;
{
	mode = MOVE_LINK;
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, link_cursor, NULL);
	put_text("Please point to the edge whose intermediate point to be moved.");
}

void
REMOVE_LINK_proc(item, event)
Menu_item item;
Event *event;
{
	mode = REMOVE_LINK;
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, link_cursor, NULL);
	put_text("Please point to the edge to be removed .");
}

void
CHANGE_LINK_LABEL_proc(item, event)
Menu_item item;
Event *event;
{
	mode = CHANGE_LINK_LABEL;
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, link_cursor, NULL);
	put_text("Please point to the edge label or the edge.");
}

void
SAVE_SUB_GRAPH_proc(item, event)
Menu_item item;
Event *event;
{
	mode = SAVE_SUB_GRAPH;
	strcpy(askname, "Enter the protocol name of the sub-graph : ");
	strcpy(name, "test");
	nameptr = strlen(name) - 1;
	namelength = NAME_LENGTH;
	sw = READING_PROTOCOL_NAME;
	write_text(askname, name);
	canvas_reader = name_reader;
}

void
PLACE_SUB_GRAPH_proc(item, event)
Menu_item item;
Event *event;
{
	mode = PLACE_SUB_GRAPH;
	strcpy(askname, "Enter the protocol name of the graph : ");
	strcpy(name, "test");
	nameptr = strlen(name)-1;
	namelength = PROTOCOL_NAME_LENGTH;
	sw = READING_PROTOCOL_NAME;
	write_text(askname, name);
	canvas_reader = name_reader;
}

void
MOVE_SUB_GRAPH_proc(item, event)
Menu_item item;
Event *event;
{
	mode = MOVE_SUB_GRAPH;
	put_text("Please point to the upper left conner of the sub-graph to be removed."); 
}

void
REMOVE_SUB_GRAPH_proc(item, event)
Menu_item item;
Event *event;
{
	mode = REMOVE_SUB_GRAPH;
	put_text("Please point to the upper left conner of the sub-graph to be removed.");
}

void
CREATE_GRAPH_proc(item, event)
Menu_item item;
Event *event;
{
	int result;

	mode = CREATE_GRAPH;
	result = notice_prompt(canvas, NULL,
				NOTICE_MESSAGE_STRINGS, "Have you stored the current graph?", 
					"Create new graph will destroy the current graph.", NULL,
                NOTICE_BUTTON_YES, "Go ahead with the creation",
                NOTICE_BUTTON_NO, "Cancel the creation",
                NULL);			
	if (result == NOTICE_YES) {
		release_objects();
		paint_canvas();
		strcpy(askname, "Enter the protocol name of the new graph : ");
		strcpy(name, protocol_name);
		nameptr = strlen(name)-1;
		namelength = NAME_LENGTH;
		sw = READING_PROTOCOL_NAME;
		write_text(askname,name);
		canvas_reader = name_reader;
	}
}

void
MOVE_GRAPH_proc(item, event)
Menu_item item;
Event *event;
{
	mode = MOVE_GRAPH;
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, node_cursor, NULL);
	put_text("Please point to a reference node.");
}

void
LOAD_GRAPH_proc(item, event)
Menu_item item;
Event *event;
{
	mode = LOAD_GRAPH;
	cur_cursor = (Xv_Cursor) xv_get(canvas_paint_window(canvas), WIN_CURSOR);
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, wait_cursor, NULL);
	load_proc();
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, cur_cursor, NULL);
	return;
}

void
STORE_GRAPH_proc(item, event)
Menu_item item;
Event *event;
{
	mode = STORE_GRAPH;
	cur_cursor = (Xv_Cursor) xv_get(canvas_paint_window(canvas), WIN_CURSOR);
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, wait_cursor, NULL);
	store_proc();
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, cur_cursor, NULL);
}

void
EDIT_MACHINE_proc(item, event)
Menu_item item;
Event *event;
{
			mode = EDIT_MACHINE;
			if (g == P[1].g) {
				g = P[0].g;
				strcpy(name, P[0].name);
				if (machine_exist[0] == 0) {
					paint_canvas();
					put_text_back();
					DX = g->DX = 0; DY = g->DY = 0;
					draw_graph();
					}
				else {
					DX = g->DX; DY = g->DY;
					}
			} else {
				g = P[1].g;
				strcpy(name, P[1].name);
				if (machine_exist[1] == 0) {
					paint_canvas();
					put_text_back();
					DX = g->DX = 0; DY = g->DY = 0;
					draw_graph();
					}
				else {
					DX = g->DX; DY = g->DY;
					}
				}
			erase_machine_name();
			strcpy(askname, "Please correct the machine name : ");
			nameptr = strlen(name)-1;
			namelength = NAME_LENGTH;
			sw = READING_MACHINE_NAME;
			write_text(askname,name);
			canvas_reader = name_reader;
}

void
REDISPLAY_proc(item, event)
Menu_item item;
Event *event;
{
	mode = REDISPLAY;
	cur_cursor = (Xv_Cursor) xv_get(canvas_paint_window(canvas), WIN_CURSOR);
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, wait_cursor, NULL);
	redisplay_proc();
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, cur_cursor, NULL);
}

void
ANALYZE_proc(item, event)
Menu_item item;
Event *event;
{
	mode = ANALYZE;
	paint_canvas();
	clear_msg();
	put_text("Displaying the machines of the protocol");
	display_protocol();
	mode = MACHINE_EXIST;
	put_text_high("Select 'RG from initial state' to generate RG.");
	menu_selected = menu1_selected;
}

void
CLEAR_proc(item, event)
Menu_item item;
Event *event;
{
	mode = CLEAR; 
	release_graph();
	paint_canvas();
	clear_msg();
}

edit_menu_selected(ie)
Event *ie;
{
    Event *event;

    menu_show(edit_menu, canvas, event, NULL);
    reset_canvas_reader();
}

