#define 	RG	0
#define		PG	1
#define		HG	2
/* hierarchy of RG's */
#define		PA	3


/****************/
#define 	DRAW	1
#define		ERASE	0

#define		SAVED	0
#define		MODIFIED	1
#define		INITIALIZED	0

typedef struct cd
		{
		int x,
		y;
		} COORD;
#define point	COORD
#include <math.h>

struct GRAPH	{ int 			 type; /* RG, PG, HG */
		  int 			 no;
		  int			 DX, DY;
		  char 			name[20];
		  int			status;	/* INITIALIZED, SAVED, or MODIFIED */
		  int 			 node_no, link_no, rspt_no, label_no;
		  struct g_node 	**node_array;
		  struct g_node    	*first_node;
		  struct g_node   	*initial_node;
		  struct g_link		**link_array;
		  struct g_link    	*first_link;
		  struct g_link    	*last_link;
		  struct g_rspt		**rspt_array;
		  struct g_rspt    	*first_rspt;
		  struct g_label 	**label_array;
		  struct g_label   	*first_label;
		  };


struct g_node	{ short			 no;
		  int			 ssno; /* RG field, for PG, ssno = -1*/
		  int			 x, y;
		  char			 *label; /* PG field, for RG blank */
		  int			 reachable; /* Yes = 1, NO - 0       */
		  struct g_link		*inlink;
		  struct g_link		*outlink;
		  struct g_node		*next;  /* in ascending order of x, y*/
		} ;

struct g_port	{ int			 x, y;
		  struct g_node		*node; 
		} ;


struct g_link	{ short			 no;
		  int			 type;
		  int 			 arcno;
		  int 			 reachable;
		  int			 channel_type; /* uni-directional = 0, bi-directional = 1 */
		  struct g_port		 src_port;
		  struct g_port		 dst_port;
		  struct g_label	*label;
		  struct g_rspt		*rest_points;
		  struct g_link		*inlink;
		  struct g_link		*outlink;
		  struct g_link		*next;
		};

struct g_rspt	{ short			 no;
		  int			 x, y;
		  struct g_link		*link;
		  struct g_rspt		*next_inlink;
		  struct g_rspt		*next;  /* in ascending order of x, y*/
		} ;

struct g_label	{ short			 no;
		  int 			 x, y;
		  int			 w, h;
		  char			 *name; /* the first char + or - */
		  char			 abn; /* abb name */
		  struct g_link		*link;
		  struct g_label	*next;
		};

struct NODE_LIST {	struct g_node *node;
			struct NODE_LIST *next;
			};

struct LINK_LIST {	struct g_link *link;
			struct LINK_LIST *next;
			};

struct RSPT_LIST {	struct g_rspt *rspt;
			struct RSPT_LIST *next;
			};

struct LABEL_LIST {	struct g_label *label;
			struct LABEL_LIST *next;
			};

struct twod_coord	{int x, y};

#define		HNTP		17
#define		HSTP		33
/* Half Node TemPlate */
#define    	GRAPH_SIZE	sizeof(struct GRAPH)
#define		Rg_SIZE		sizeof(struct Rg)
#define		G_NODE_SIZE	sizeof(struct g_node)
#define		G_PORT_SIZE	sizeof(struct g_port)
#define		G_LINK_SIZE	sizeof(struct g_link)
#define		G_RSPT_SIZE	sizeof(struct g_rspt)
#define		G_LABEL_SIZE	sizeof(struct g_label)
#define		HARROW_WIDTH	4
#define		ARROW_LENGTH	12

#define		LINK_TOL	7     /* link tolerance  */
#define		NODE_TOL	18    /* node tolerance  */
#define         STATE_TOL	36    /* state tolerance  */
