#include <stdio.h>
#include <xview/xview.h>
#include "tool.h"
#include "g.h"
#include "state.h"
#include "menu.h"
#include "ext.h"
#include "extxv.h"

extern GC gcClear;
extern GC gcSet;
extern GC gcDraw;
extern GC gcErase;
extern GC gcINV;
extern GC gcHighlight;
extern Xv_Font font;
extern Xv_Font font6;
extern GC gcTemplate[13];
extern GC  gcInitNode;


pwClearBackground(x, y, w, h)
int x, y, w, h;
{
	XFillRectangle(display, drawable, gcSet, x, y, w, h);
	
}

pwClearArea(x, y, w, h)
int x, y, w, h;
{
	XFillRectangle(display, drawable, gcSet,
		x/zoom - 1, y/zoom - 2, w/zoom + 3, h/zoom + 4);
}

pwHighlightArea(x, y, w, h)
int x, y, w, h;
{
	XFillRectangle(display, drawable, gcHighlight, 
		x/zoom - 1, y/zoom - 2, w/zoom + 3, h/zoom + 4);
}

pwVector(x1,y1,x2,y2)
int x1,y1,x2,y2;
{
	/*
	XDrawLine(display, drawable, gcINV, x1/zoom,y1/zoom,x2/zoom,y2/zoom);
	*/
	XDrawLine(display, drawable, gcDraw, 
		(x1+DX)/zoom,(y1+DY)/zoom,(x2+DX)/zoom,(y2+DY)/zoom);
}

draw_vector(x1,y1,x2,y2)
int x1,y1,x2,y2;
{
	/*
	XDrawLine(display, drawable, gcDraw, 
	*/
	XDrawLine(display, drawable, gcINV, 
		(x1+DX)/zoom,(y1+DY)/zoom,(x2+DX)/zoom,(y2+DY)/zoom); 
}

erase_vector(x1,y1,x2,y2)
int x1,y1,x2,y2;
{
	/*
	XDrawLine(display, drawable, gcErase, 
	*/
	XDrawLine(display, drawable, gcINV, 
		(x1+DX)/zoom,(y1+DY)/zoom,(x2+DX)/zoom,(y2+DY)/zoom);
}

draw_machine_name()
{
	int i;

	if (g->type == PG) {
	/*
	   if (g == P[1].g) strcpy(buf, P[1].name);
	   else strcpy(buf, P[0].name);
	   i = strlen(buf);
	   if (g->initial_node != 0) 
			pwtext(g->initial_node->x - 4*i + DX, 
				g->initial_node->y - 35 + DY, buf);
	*/
		strcpy(buf, g->name);
		i = strlen(buf);
		if (g->initial_node != 0) 
			pwtext((g->initial_node->x - 4*i + DX)/zoom, 
				(g->initial_node->y - 35 + DY)/zoom, buf);
	}
}

erase_machine_name()
{
	draw_machine_name();
}

draw_graph()
/* 
   Before do any drawing on graph, 
   you have to 
      1. change the global graph variable g.
      2. set up global reference point (DX,DY),  
*/
{
	struct g_link	*link;
	struct g_node	*n;
	struct g_label  *label;
	char 		 buf[20];
	int i;

	fprintf(stderr, "draw_graph: DX=%d, DY=%d.\n", DX, DY);
	if (g == 0) {
		fprintf(stderr, "g is null\n");
		return;
		}
	if (g == rg[0]->g) rg_exist = 1;
	if (g == P[0].g) machine_exist[0] = 1;
	if (g == P[1].g) machine_exist[1] = 1;
	fprintf(stderr, "draw_graph: starting...\n");
	for (n = g->first_node; n != 0; n = n->next) {
	    draw_node(n->x, n->y);
	    }
	for (n = g->first_node; n != 0; n = n->next) {
	    write_node_label(n);
	    }
	if (g->type == PG) draw_initial_node_symbol(g->initial_node);

	for (link = g->first_link; link != 0; link = link->next)
	    draw_link(link);

	for (label = g->first_label; label != 0; label = label->next)
	    write_edge_label(label); 
	draw_machine_name();
	if (g->type == RG) {
	   pwtext((DX-31)/zoom, (DY-35)/zoom, "RG");
	   }
	if (g->type == HG) 
	   pwtext((DX-45)/zoom, (DY - 35)/zoom, "RG_TOPOLOGY");
	if (g->type == PA) {
	   sprintf(buf, "PATH");
	   for (n = g->first_node; n != 0; n = n->next)
		if (n->no == 1) break;
	   pwtext((DX + 4)/zoom , (DY + n->y - 35)/zoom, buf);
	   }
	if (g->type == RG) {
		for (i= 0; i <= 1; i++)
			if (g == rg[i]->g) {
				highlight_error_states(i);
				return;
				}
		}
}

erase_graph()
{
 	paint_canvas();
}

relocate_graph()
{
	g->DX = DX; g->DY = DY;
	modified();
	}

highlight_edge_label(L)
struct g_label *L;
{
	Font_string_dims dims;

	if (L == 0) return;
	(void) xv_get(font, FONT_STRING_DIMS, L->name, &dims);
	pwHighlightArea(L->x + DX, L->y - dims.height + 8 + DY, 
		dims.width, dims.height); 
	/* write_edge_label(L); */
}

dim_highlight_edge_label(L)
struct g_label *L;
{
	Font_string_dims dims;

	if (L == 0) return;
	(void) xv_get(font, FONT_STRING_DIMS, L->name, &dims);
	pwHighlightArea(L->x + DX, L->y - dims.height + 8 + DY, 
		dims.width, dims.height); 
	/*
	pwClearArea(L->x + DX, L->y - dims.height + 8 + DY, 
				dims.width, dims.height);
	write_edge_label(L);
	*/
}

write_edge_label(L)
struct g_label *L;
{
	char buf[3];

	if (L == 0) return;
	if (link_drawing_mode == FAST && (mode == MOVE_NODE || mode == MOVE_LINK))
		pwtext((DX+L->x)/zoom, (DY+L->y + 5)/zoom, L->name);
	else pwtext((DX+L->x)/zoom, (DY+L->y + 5)/zoom, L->name);
}

erase_edge_label(L)
struct g_label *L;
{
	char buf[3];

	if (L == 0) return;
	if (link_drawing_mode == FAST && (mode == MOVE_NODE || mode == MOVE_LINK))
		pwtext((DX+L->x)/zoom, (DY+L->y+5)/zoom, L->name);
	else pwtext((DX+L->x)/zoom, (DY+L->y+5)/zoom, L->name);
}

highlight_node(cx, cy)
int	cx, cy;
{
	register int	x, y, s;

	x = cx -  ((g->type == RG || g->type == PA) ? STP_HALF  : TP_HALF );
	y = cy -  ((g->type == RG || g->type == PA) ? STP_HALF  : TP_HALF );
	s = (g->type == RG || g->type == PA) ? STP_SIZE  : TP_SIZE ;
	pwHighlightArea(x + DX, y + DY, s, s);
}

draw_node(cx, cy)
int	cx, cy;
{
	register int	x, y, s, z, d;
	
	cx = cx+DX;
	cy = cy+DY;
	x = cx/zoom - STP_HALF;
	y = cy/zoom - STP_HALF;
	d = 3;
	if (g->type == RG || g->type == PA) d = 7;
	if (zoom == 1) z = 1;
	if (zoom == 2) z = 2;
	if (zoom == 4) z = 3;
	if (zoom == 8) z = 4;
	if (zoom == 16) z = 5;
	/*
	XFillRectangle(display,drawable, gcTemplate[d+z], x, y, STP_SIZE, STP_SIZE);
	XCopyArea(display, (Drawable)xv_get(xbitmap[d+z],XV_XID), drawable, gcINV, 
		0, 0, 64, 64, x, y);
	*/
	XCopyPlane(display, xbitmap[d+z], drawable, gcDraw, 
		0, 0, 64, 64, x, y, 1);
}

erase_node(cx, cy)
int	cx, cy;
{
	register int	x, y, s, z, d;
	
	cx = cx+DX;
	cy = cy+DY;
	x = cx/zoom - STP_HALF;
	y = cy/zoom - STP_HALF;
	d = 3;
	if (g->type == RG || g->type == PA) d = 7;
	if (zoom == 1) z = 1;
	if (zoom == 2) z = 2;
	if (zoom == 4) z = 3;
	if (zoom == 8) z = 4;
	if (zoom == 16) z = 5;
	XCopyPlane(display, xbitmap[d+z], drawable, gcErase, 
		0, 0, 64, 64, x, y, 1);
}

draw_initial_node_symbol(node)
struct g_node *node;
{

	if (node == 0) return;
	if (zoom == 0) {
		x = (node->x + DX)*2 - 8;
		y = (node->y + DY)*2 - 49;
	} else if (zoom == 2) {
		x = (node->x + DX)/zoom - 8;
		y = (node->y + DY)/zoom - 25;
	} else if (zoom == 1) {
		x = node->x + DX - 8;
		y = node->y + DY - 33;
	} else return;
	XCopyPlane(display, initial_node_pixmap, drawable, gcDraw, 
		0, 0, 16, 16, x, y, 1);
}

erase_initial_node_symbol(node)
struct g_node *node;
{
	if (node == 0) return;
	if (zoom == 0) {
		x = (node->x + DX)*2 - 8;
		y = (node->y + DY)*2 - 49;
	} else if (zoom == 2) {
		x = (node->x + DX)/zoom - 8;
		y = (node->y + DY)/zoom - 25;
	} else if (zoom == 1) {
		x = node->x + DX - 8;
		y = node->y + DY - 33;
	} else return;
	XCopyPlane(display, initial_node_pixmap, drawable, gcErase, 
		0, 0, 16, 16, x, y, 1);
}

highlight_vector(x1, y1, x2, y2)
int x1, x2, y1, y2;
{
	int i,j;

	for (i = -1; i < 2; i++) 
	   for (j = -1; j < 2; j++) 
	      draw_vector(x1 + i, y1 + j, x2 + i, y2 + j);
}

highlight_link(link)
struct g_link	*link;
{
	int		 x, y;
	struct g_rspt	*p;

	if (link == 0) return;
	if (link_drawing_mode == DELICATE && 
		(link->type == B_SPLINE || link->type == T_SPLINE))
		return;
	if (link->src_port.x == -1) {
	    x = link->rest_points->x;
	    y = link->rest_points->y;
	    p  = link->rest_points->next_inlink;
	    }
	else {
	    x = link->src_port.x;
	    y = link->src_port.y;
	    p  = link->rest_points;
	    }

	for (; p != 0; p = p->next_inlink) {
	    highlight_vector(x, y, p->x, p->y);
	    x = p->x;
	    y = p->y;
	    }

	if (link->dst_port.x != -1) 
	    highlight_vector(x, y, link->dst_port.x, link->dst_port.y);
	}

highlight_arc_and_link(link)
struct g_link *link;
{
	int arcno, processno, edgeno;
	struct g_link *l;
	int ssn, x, y;

	if (link == 0) return;
	highlight_link(link);
	highlight_edge_label(link->label);
	arcno = link->arcno;
	processno = arc[arcno].processno;
	edgeno = arc[arcno].edgeno;
	for (l = P[processno].g->first_link; l != 0; l = l->next)
		if (l->no == edgeno) {
			struct GRAPH *save_g;

			save_g = g;
			g = P[processno].g;
			DX = g->DX; DY = g->DY;
			highlight_link(l);
			highlight_edge_label(l->label);
			/***  show content of the two channels ***/
	ssn = arc[arcno].srcssno;
	DX = 0; DY = 0;
	x = 450 - strlen(ss[ssn].c[1].m) * 4;
	y = 150 + 3;
	pwtext(x + DX, y + DY, ss[ssn].c[1].m);
	x = 450 - strlen(ss[ssn].c[0].m) * 4;
	y = 250 + 3;
	pwtext(x + DX, y + DY, ss[ssn].c[0].m);
			g = save_g;
			if (g == 0) { 
				DX = 0; DY = 0; 
			} else {
				DX = g->DX; DY = g->DY;
				}
			return;
			}
}

dim_highlight_arc_and_link(link)
struct g_link *link;
{
	int arcno, processno, edgeno;
	struct g_link *l;
	int ssn, x, y;

	if (link == 0) return;
	highlight_link(link);
	dim_highlight_edge_label(link->label);
	arcno = link->arcno;
	processno = arc[arcno].processno;
	edgeno = arc[arcno].edgeno;
	for (l = P[processno].g->first_link; l != 0; l = l->next)
		if (l->no == edgeno) {
			struct GRAPH *save_g;

			save_g = g;
			g = P[processno].g;
			DX = g->DX; DY = g->DY;
			highlight_link(l);
			dim_highlight_edge_label(l->label);
			/***  erase content of the two channels ***/
	ssn = arc[arcno].srcssno;
	DX = 0; DY = 0;
	x = 450 - strlen(ss[ssn].c[1].m) * 4;
	y = 150 + 3;
	pwtext(x + DX, y + DY, ss[ssn].c[1].m);
	x = 450 - strlen(ss[ssn].c[0].m) * 4;
	y = 250 + 3;
	pwtext(x + DX, y + DY, ss[ssn].c[0].m);
			g = save_g;
			if (g == 0) { 
				DX = 0; DY = 0; 
			} else {
				DX = g->DX; DY = g->DY;
				}
			return;
			}
}

highlight_state_and_node(node)
struct g_node *node;
{
	struct g_node *n;
	struct GRAPH *save_g;
	int ssn, x, y;

	if (node == 0) return;
	highlight_node(node->x, node->y);
	g->DX = DX;
	g->DY = DY;
	save_g = g;
	DX = -6; DY = 5;
	g = P[1].g;
	ssn = abs(node->ssno);
	if (ssn == 99999) ssn = 0;
	n = search_node(g, ss[ssn].pn[1]);
	highlight_node(n->x, n->y);

	DX = 500; 
	g = P[0].g;
	n = search_node(g, ss[ssn].pn[0]);
	highlight_node(n->x, n->y);

	DX = 0; DY = 0;
	x = 450 - strlen(ss[ssn].c[1].m) * 4;
	y = 150 + 3;
	pwtext(x + DX, y + DY, ss[ssn].c[1].m);
	x = 450 - strlen(ss[ssn].c[0].m) * 4;
	y = 250 + 3;
	pwtext(x + DX, y + DY, ss[ssn].c[0].m);
	g = save_g;
	DX = g->DX; DY = g->DY;
}

draw_link(link)
struct g_link   *link;
{
	op_link(link, DRAW);
}

erase_link(link)
struct g_link *link;
{
	op_link(link, ERASE);
}

op_link(link, dore)
struct g_link	*link;
int dore;
{
	int		 x, y;
	struct g_rspt	*p;

	if ((link->type == B_SPLINE) && (link_drawing_mode == DELICATE)) {
	   if (dore == DRAW) op_spline(link, dore);
	   else   	    op_spline(link, dore);
	   return;
	   }
	if ((link->type == T_SPLINE) && (link_drawing_mode == DELICATE)) {
	   if (dore == DRAW) op_t_spline(link, dore);
	   else             op_t_spline(link, dore);
           return;
           }
	if (link->src_port.x == -1) {
	    x = link->rest_points->x;
	    y = link->rest_points->y;
	    p  = link->rest_points->next_inlink;
	    }
	else {
	    x = link->src_port.x;
	    y = link->src_port.y;
	    p  = link->rest_points;
	    }

	for (; p != 0; p = p->next_inlink) {
	/*
	    if (dore == DRAW) draw_vector(x, y, p->x, p->y);
	    else 	     erase_vector(x, y, p->x, p->y);
	*/
	    if (dore == DRAW) draw_vector(x, y, p->x, p->y);
	    else 	     erase_vector(x, y, p->x, p->y);
	    x = p->x;
	    y = p->y;
	    }

	if (link->dst_port.x != -1) {
	   if (g->type == PG) op_arc(x, y, link->dst_port.x, link->dst_port.y, dore);
	   else draw_vector(x, y, link->dst_port.x, link->dst_port.y);
	}
}

write_node_label(node)
struct g_node *node;
{
	int l,k,f,h;
	char str1[20];
	char str2[20];

   if ((g->type == PG) || (g->type == HG)) {
	if (node == 0) return;
	l = strlen(node->label);
	if (zoom == 0) {f = 2; h = 2;}
	if (zoom == 1) {f = 4; h = 4;}
	if (zoom == 2) {f = 4; h = 1;}
	if (l > 3) {
	   k = l/2 ;
	   strncpy(str1, node->label, l-k);
	   str1[l-k] = (char) 0;
	   strncpy(str2, &(node->label[l-k]), k);
	   str2[k] = (char) 0;
	   pwtext((node->x - f*(l-k)  + DX)/zoom, (node->y - h  + DY)/zoom, str1);
	   pwtext((node->x - f*(k)  + DX)/zoom, (node->y + 3*f + DY)/zoom, str2);
           }
	else pwtext((node->x - f*l + 1 + DX)/zoom, (node->y + 4 + DY)/zoom, node->label);
	}
   else 
	write_state(node->ssno, node->x, node->y);
}

erase_node_label(node)
struct g_node *node;
{
	write_node_label(node);
}

put_channels()
{
	DX = 0;
	DY = 0;
	/* channel C12 */
	highlight_vector(360,135,480,135);
	highlight_vector(480,136,480,121);
	highlight_vector(480,120,540,150);
	highlight_vector(540,150,480,180);
	highlight_vector(480,179,480,166);
	highlight_vector(480,165,360,165);
	highlight_vector(360,164,360,136);
	/* channel C21 */
	highlight_vector(540,235,420,235);
	highlight_vector(420,234,420,221);
	highlight_vector(420,220,360,250);
	highlight_vector(360,250,420,280);
	highlight_vector(420,279,420,265);
	highlight_vector(421,265,540,265);
	highlight_vector(540,264,540,236);
}

release_objects()
{
	struct g_node *fn, *node;
	struct g_link *fl, *link;
	struct g_rspt *fr, *rspt;
	struct g_label *fla, *label;

	if (g == 0) return;
	for (node = g->first_node; node != (struct g_node *)0; fn = node, node = node->next, 
		free_node(fn));
	for (link = g->first_link; link != (struct g_link *)0; fl = link, link = link->next, 
		free(fl));
	for (rspt = g->first_rspt; rspt != (struct g_rspt *)0; fr = rspt, rspt = rspt->next, 
		free(fr));
	for (label = g->first_label; label != (struct g_label *)0; fla = label, label = label->next, 
		free_label(fla));
	init_g(g);
}

release_graph()
{
	release_objects();
	free(g);
}
