#include <stdio.h>
#include <xview/xview.h>
#include "tool.h"
#include "menu.h"
#include "g.h"
#include "state.h"
#include "ext.h"


static struct g_rspt	*cur_restpt;
static struct g_rspt	*rspt;
static char		 source_port_not_decided;


#define		ERASE_LINK_SEGMENTS	1
#define		DRAW_LINK_SEGMENTS	2


static struct g_rspt	*rest_point, *rp, *prev, *next;
static struct g_node	*src_node, *dst_node;


insert_link(link)
struct g_link	*link;
{
	if (g->first_link == NULL)
	    g->first_link = link;
	else
	    g->last_link->next = link;
	g->last_link = link;
	modified();
	}

delete_link(l)
struct g_link   *l;
{
	struct g_link *prev, *link;

	for (prev = NULL, link = g->first_link; link != NULL; prev = link, link = link->next)
		if (l == link) break;
	if (l == g->first_link) g->first_link = l->next;
	else prev->next = l->next;
	if (l == g->last_link) g->last_link = prev;
	modified();
}

struct g_link *
link_search(x, y)
int x, y;
{
	struct g_link *link, *prev; 

	if (g == NULL) return(NULL);
	for (link = g->first_link, prev = NULL; link != NULL; prev = link, link = link->next) 
		if (pick_link(link, x, y, LINK_TOL))
			return(link);
	return(NULL);
}

init_linktracking(ie)
Event	*ie;
{

	cur_x = ie->ie_locx;
	cur_y = ie->ie_locy;
	src_node = node_search(cur_x,cur_y,NODE_TOL);
	if (src_node == NULL) return(0);
	cur_restpt = NULL;
	cur_link = (struct g_link *) malloc(G_LINK_SIZE);
	cur_link->no = ++(g->link_no);
	cur_link->type = link_type;
	cur_link->arcno = 0;
	cur_link->reachable = 0;
	cur_link->channel_type = channel_type;
	cur_link->inlink = NULL;
	cur_link->outlink = NULL;
	cur_link->rest_points = NULL;
	cur_link->next = NULL;
	    cur_link->src_port.x = src_node->x;
	    cur_link->src_port.y = src_node->y;
	    cur_link->src_port.node = src_node;
	    cur_link->dst_port.x = -1;
	    if (src_node->outlink != NULL)
		cur_link->outlink = src_node->outlink;
	    src_node->outlink = cur_link;
	    fix_x = src_node->x;
	    fix_y = src_node->y;
	    source_port_not_decided=1;
	draw_vector(fix_x, fix_y, cur_x, cur_y);
	put_text_high("Now point to the intermediate points of the edge,");
	put_text(" or conclude by hitting the middle button on the destination node.");
	return(1);
	}


link_tracker(ie)
Event	*ie;
{
	
	struct g_rspt *b;



	ie->ie_locx = ie->ie_locx*zoom - DX;
	ie->ie_locy = ie->ie_locy*zoom - DY;
	if (win_inputnegevent(ie)) return;

	if (ie->ie_code == MS_MIDDLE)  {
		if (place_link(ie)) {
		   if (link_type == B_SPLINE || link_type == T_SPLINE) {
		      cur_link->type = LINE;
		      op_link(cur_link, ERASE);
		      cur_link->type = link_type;
		      op_link(cur_link, DRAW);
		      }
		    init_edge_label_reader();
		    canvas_reader = edge_label_reader;
		    }
		else  {
		   /* recover from the incomplete link spec. */
		   /* and release the allocate source (rspt).*/
		   src_node->outlink = src_node->outlink->outlink;
		   if (channel_type == BI_DIRECTIONAL) src_node->inlink = src_node->inlink->inlink;
		   cur_link->type = LINE;
		   erase_link(cur_link);
		   for (rspt = cur_link->rest_points; rspt != NULL; b = rspt, rspt = rspt->next_inlink, delete_rspt(b), free(b)); 
		   put_text("Please point to the source node of the edge.");
		   reset_canvas_reader();
		   }
	    return;
	    }
	switch (ie->ie_code) {
	    case LOC_MOVE :
		erase_vector(fix_x, fix_y, cur_x, cur_y);
		cur_x = ie->ie_locx;
		cur_y = ie->ie_locy;
		draw_vector(fix_x, fix_y, cur_x, cur_y);
		return;
            case LOC_WINEXIT:
		return;
	    case MS_LEFT :		/*  two buttons down?	     */ 
		erase_vector(fix_x, fix_y, cur_x, cur_y);
		cur_x = ie->ie_locx;
		cur_y = ie->ie_locy;
		draw_vector(fix_x, fix_y, cur_x, cur_y);
		if (fix_x == ie->ie_locx && fix_y == ie->ie_locy) return;
		if (place_restpt(ie->ie_locx, ie->ie_locy)) {
		   fix_x = ie->ie_locx;
		   fix_y = ie->ie_locy;
		   }
		return;
	    }				/* ignore all other input  */
}

angle_calc(p,q,t)
point p,q;
double *t;
{	double tabs;

	if ((q.x-p.x)==0) {
	   if ((q.y > p.y)) *t=hpi;
	   else *t=hpi+hpi+hpi;
	   } else { 
	   	    tabs =  atan (((double) (q.y-p.y))/((double)(q.x-p.x)));
  	            if ((q.x-p.x) > 0) {
	   	       if ((q.y - p.y) > 0)	*t=tabs;
	   	       else 			*t=hpi+hpi+hpi+hpi+tabs;
		    }else if ((q.y - p.y) > 0) 	*t=hpi+hpi+tabs;
	      	          else			*t=hpi+hpi+tabs;
		  }
}

op_arrow_head(px,py,qx,qy,dore)
int px,py,qx,qy,dore;
{


	point p,q;
	int i,gx,gy,bx,by;
	double t,ta,dx,dy;

	if (arrow_head_drawing_mode == NO_ARROW_HEAD) return; /* when move node : no arrow head */
	p.x=px;
	p.y=py;
	q.x=qx;
	q.y=qy;
	angle_calc(p,q,&t);
	ta= t+hpi;
	dx = (HARROW_WIDTH * cos(ta));
	dy = (HARROW_WIDTH * sin(ta));
	gx=q.x + (int)(ARROW_LENGTH * cos(t+hpi+hpi));
	gy=q.y + (int)(ARROW_LENGTH * sin(t+hpi+hpi));
	for (i=4; i > -5 ; i--) {
        if ((arrow_head_drawing_mode == SPEAR) && (i > -4) && (i < 4)) continue; /* simple arc */
	    bx = gx + dx * i / 4.0;
	    by = gy + dy * i / 4.0;
		/*
		if (dore == DRAW) draw_vector(bx, by, qx, qy);
		else erase_vector(bx, by, qx, qy);
		*/
		if (dore == DRAW) draw_vector(bx, by, qx, qy);
		else erase_vector(bx, by, qx, qy);
	}
}

op_arc(px,py,qx,qy, dore)
int px,py,qx,qy;
{
	/*
	draw_vector(px,py,qx,qy);
	op_arrow_head(px,py,qx,qy, dore);
	*/
	draw_vector(px,py,qx,qy);
	op_arrow_head(px,py,qx,qy, dore);
}

draw_arc(px,py,qx,qy)
int px,py,qx,qy;
{
	op_arc(px,py,qx,qy, DRAW);
}

erase_arc(px,py,qx,qy)
int px,py,qx,qy;
{
	op_arc(px,py,qx,qy, ERASE);
}

char
lineseg_intersect(isx,L,a,b,p,q,r)
char isx;
int L,a,b;
point p,q, *r;
{	/* if isx=1, check x=L, (a<=x<=b) intersect with p->q line segment */

	if (isx) { /* x=L */
	   if (p.x==q.x)  return(0); /* no intersection */
	   else { r->x = L;
		  r->y = (int) (p.y+((p.y-q.y)/ (float)(p.x-q.x))*(L- p.x));
		  if (r->y >= a && r->y <= b) return(1);
		  else return(0);
		}
	}else if (p.y==q.y)  return(0);
	      else { r->x = (int)(p.x+((p.x-q.x)/ (float)(p.y-q.y))*(L-p.y));
		     r->y = L;
		     if (r->x >= a && r->x <= b) return(1);
		     else return(0);
		   }
}

char
find_port(cur,sn,r)
point cur,sn, *r;
/* 	find the intersection point, r, between point cur and node sn */
{
	int L, K, TP;

	TP = (g->type == PG) ? HNTP : HSTP;
	if (sn.x > cur.x)  L = sn.x - TP;
		else 	   L = sn.x + TP;
	if (sn.y > cur.y)  K = sn.y - TP;
		else	   K = sn.y + TP;
	if (lineseg_intersect(1,L,sn.y-TP,sn.y+TP,cur,sn,r)==0)
	   if (lineseg_intersect(0,K,sn.x-TP,sn.y+TP,cur,sn,r)==0)
	      return(0);
	return(1);
}

place_link(ie)
Event	*ie;
{
	struct g_node 	*dst_node;
	point 		 fix,dn,r,sn;

	erase_vector(fix_x, fix_y, cur_x, cur_y);
	dst_node = node_search(ie->ie_locx, ie->ie_locy, NODE_TOL);
	if (dst_node == NULL)  return(0);
	if (cur_link->src_port.node == dst_node &&
	    cur_link->rest_points == NULL) return(0);
	dn.x = dst_node->x;
	dn.y = dst_node->y;
	if (cur_restpt == NULL) {
		sn.x = src_node->x;
		sn.y = src_node->y;
		find_port(dn,sn,&r);
		fix_x = r.x;
		cur_link->src_port.x = r.x;
		fix_y = r.y;
	 	cur_link->src_port.y = r.y;
 		find_port(sn, dn, &r);
		}
	fix.x = fix_x;
	fix.y = fix_y;
	find_port(fix, dn, &r);
	cur_link->dst_port.x = r.x;
        cur_link->dst_port.y = r.y;
	cur_link->dst_port.node = dst_node;
        if (dst_node->inlink != NULL)
		cur_link->inlink = dst_node->inlink;
        dst_node->inlink = cur_link;
        draw_arc(fix_x, fix_y, r.x, r.y);
	insert_link(cur_link);
	return(1);
	}

place_restpt(x, y)
int	x, y;
{
	struct g_rspt	*rest_point;
	struct g_node   *node;

	modified();
	node = node_search(x, y, NODE_TOL);
	if (node != NULL) return(0);
	rest_point = (struct g_rspt *) malloc(G_RSPT_SIZE);
	rest_point->no = ++(g->rspt_no);
	rest_point->x = x;
	rest_point->y = y;
	rest_point->link = cur_link;
	rest_point->next_inlink = NULL;
	rest_point->next = NULL;
	insert_rspt(rest_point);

	if (cur_link->rest_points == NULL)
	    cur_link->rest_points = rest_point;
	else
	    cur_restpt->next_inlink = rest_point;
	cur_restpt = rest_point;
	modify_src_port(x,y);
	return(1);
}

modify_src_port(x,y)
int x,y;
{	point r,cur,sn;

if (source_port_not_decided) {
	/* decide source port's coordinate */
	cur.x = x;
	cur.y = y;
	sn.x = src_node->x;
	sn.y = src_node->y;
	find_port(cur,sn,&r);
	erase_vector(sn.x,sn.y,x,y);
	cur_link->src_port.x = r.x;
	cur_link->src_port.y = r.y;
	draw_vector(r.x, r.y, x, y);
	source_port_not_decided=0;
	}
}
 
init_linkmoving(ie)
Event	*ie;
{

	link = link_search(ie->ie_locx, ie->ie_locy);
	if (link == NULL) return(1);
	return(0);
}

rest_point_reader(ie)
Event       *ie;
{
	register int	 x, y;

	ie->ie_locx = ie->ie_locx*zoom - DX;
	ie->ie_locy = ie->ie_locy*zoom - DY;

	switch (ie->ie_code) {
	case MS_MIDDLE:
	case CNTL_C :
		reset_canvas_reader();
		erase_link(link);
		link_drawing_mode = save_link_drawing_mode;
		arrow_head_drawing_mode = save_arrow_head_drawing_mode;
		draw_link(link);
		put_text_high("Please point to the edge whose intermediate point to be moved;");
		put_text("   or select the middle button menu.");
		return;
	case MS_LEFT :
		x = ie->ie_locx;
		y = ie->ie_locy;
		rest_point = rspt_search(x, y, LINK_TOL);
		if (rest_point == NULL) {
			put_text_high("Please point to the intermediate point to be moved;");
			put_text("   or hit middle button to exit.");
			return;
			}
	
		fix_x = rest_point->x;
		fix_y = rest_point->y;
		cur_x = fix_x;
		cur_y = fix_y;
		/* winsetmouseposition(cswfd, cur_x, cur_y); */
		link = rest_point->link;
		prev = NULL;
		for (rp = link->rest_points; rp != rest_point; rp = rp->next_inlink) {
			prev = rp;
		}
		if (prev == NULL) src_node = link->src_port.node;
		else		  src_node = NULL;
		if ((next = rest_point->next_inlink) == NULL) 
			dst_node = link->dst_port.node;
		else    dst_node = NULL;
		canvas_reader = movelink_tracker;
		put_text("   conclude with middle button; CNTL_C for original positon.");
		put_text_high("Now move the intermediate point;");
		return;
	}
}

movelink_tracker(ie)
Event	*ie;
{


	ie->ie_locx = ie->ie_locx*zoom - DX;
	ie->ie_locy = ie->ie_locy*zoom - DY;
	switch (ie->ie_code) {
	case CNTL_C :	
		erase_vectors();
		cur_x = fix_x;
		cur_y = fix_y;
		draw_vectors();
	case MS_MIDDLE :
		relocate_rspt();
		reset_canvas_reader();
		erase_link(link);
		link_drawing_mode = save_link_drawing_mode;
		arrow_head_drawing_mode = save_arrow_head_drawing_mode;
		draw_link(link);
		put_text_high("Please point to the edge whose intermediate point to be moved;");
		put_text("   or select the middle button menu.");
		return;
	case LOC_MOVE:
		erase_vectors();
		cur_x = ie->ie_locx;
		cur_y = ie->ie_locy;
		draw_vectors();
		return;
	case LOC_WINEXIT :
		return;
	}
}

op_rspt(sw)
int 	sw;
{
	point cur, n, p;

	if (sw == ERASE_LINK_SEGMENTS) {
		/* upper link segment  */
		if (prev == NULL) { /* rest_point is the first in link */
			erase_vector(link->src_port.x, link->src_port.y, cur_x, cur_y);
			erase_edge_label(link->label);
		}
		else erase_vector(prev->x, prev->y, cur_x, cur_y);

		/* lower link segment  */
		if (next == NULL) 
			erase_arc(cur_x, cur_y, link->dst_port.x, link->dst_port.y);
		else 
		    erase_vector(cur_x, cur_y, next->x, next->y);
	}
	if (sw == DRAW_LINK_SEGMENTS) {
		cur.x = cur_x; 
		cur.y = cur_y;
		if (prev == NULL) {
			n.x = src_node->x;
			n.y = src_node->y;
			find_port(cur, n, &p);
			link->src_port.x = p.x;
			link->src_port.y = p.y;
			draw_vector(p.x, p.y, cur_x, cur_y);
			link->label->x = cur_x + 3;
			link->label->y = cur_y - 3;
			write_edge_label(link->label);
		}
		else draw_vector(prev->x, prev->y, cur_x, cur_y);

		if (next == NULL) {
			n.x = dst_node->x;
			n.y = dst_node->y;
			find_port(cur, n, &p);
			link->dst_port.x = p.x;
			link->dst_port.y = p.y;
			draw_arc(cur_x, cur_y, p.x, p.y);
		}
		else draw_vector(cur_x, cur_y, next->x, next->y);
	}
}

erase_vectors()
{
	op_rspt(ERASE_LINK_SEGMENTS);
}

draw_vectors()
{
	op_rspt(DRAW_LINK_SEGMENTS);
}

relocate_rspt()
{

	delete_rspt(rest_point);
	rest_point->next = NULL;
	rest_point->x = cur_x;
	rest_point->y = cur_y;
	insert_rspt(rest_point);
	modified();
}

remove_link_from_inlink_and_outlink(link)
struct g_link *link;
{
	struct g_link   *f, *b;

		modified();
		for (b = NULL, f = 
			(link->dst_port.node == NULL) ? NULL
				: link->dst_port.node->inlink;
			f != link && f != NULL; b = f, f = f->inlink)  ;
		if (f != NULL) {if (b == NULL)
		      		   (link->dst_port.node)->inlink = link->inlink;
	        		else b->inlink = link->inlink;
				}
		for (b = NULL, f = 
			(link->src_port.node == NULL) ? NULL
				: link->src_port.node->outlink;
			f != link && f != NULL; b = f, f = f->outlink) ;
		if (f != NULL) {if (b == NULL)
		      		 (link->src_port.node)->outlink = link->outlink;
	        		else b->outlink = link->outlink;
				}
}

remove_link(x, y)
int	x, y;
{
	struct g_link	*link, *prev;

	modified();
	for (link = g->first_link, prev = NULL; link != NULL; prev = link, link = link->next) {
	    if (pick_link(link, x, y, LINK_TOL)) {
		op_link(link, ERASE);
		remove_restpt(link);
		if (link == g->first_link) 
		    g->first_link = link->next;
		else 
		    prev->next = link->next;
		if (link == g->last_link) g->last_link = prev;
		remove_label(link);
		remove_link_from_inlink_and_outlink(link);
		free(link);
		return;
		}
	    }
	}

pick_link(link, xp, yp, d)     /* return 0 if (xp, yp) is not close to */
struct g_link	*link;         /*          any link, 		       */
int		 xp, yp, d;    /*        1 otherwise		       */
{
	struct g_rspt	*rest_point;
	int		 x1, y1, x2, y2;
	float		 dist2;

	if (link->src_port.x == -1) {
	    x1 = link->rest_points->x;
	    y1 = link->rest_points->y;
	    rest_point  = link->rest_points->next_inlink;
	    }
	else {
	    x1 = link->src_port.x;
	    y1 = link->src_port.y;
	    rest_point  = link->rest_points;
	    }

	dist2 = (float) (d * d);

	for (; rest_point != NULL; rest_point = rest_point->next_inlink) {
	    x2 = rest_point->x;
	    y2 = rest_point->y;
	    if (close_to_vector(x1, y1, x2, y2, xp, yp, d, dist2)) return(1);
	    x1 = x2;
	    y1 = y2;
	    }

	if (link->dst_port.x == -1) return(0);
	if (close_to_vector(x1, y1, link->dst_port.x, link->dst_port.y, xp, yp, d, dist2))
	    return(1);
	return(0);
	}


close_to_vector(x1, y1, x2, y2, xp, yp, d, dist2)
int	 x1, y1, x2, y2, xp, yp, d;
float	 dist2;
{
	int	xmin, ymin, xmax, ymax;
	float	x, y, slope, D2, dx, dy;

	if (x1 < x2) {
	    xmin = x1 - d; xmax = x2 + d;
	    }
	else {
	    xmin = x2 - d; xmax = x1 + d;
	    }
	if (xp < xmin || xmax < xp) return(0);

	if (y1 < y2) {
	    ymin = y1 - d; ymax = y2 + d;
	    }
	else {
	    ymin = y2 - d; ymax = y1 + d;
	    }
	if (yp < ymin || ymax < yp) return(0);

	if (x2 == x1) {
	    x = x1;
	    y = yp;
	    }
	else if (y1 == y2) {  
	    x = xp;
	    y = y1;
	    }
	else {
	    slope = ((float) (x2 - x1)) / ((float) (y2 - y1));
	    y = (slope * (xp - x1 + slope * y1) + yp) / (1 + slope * slope);
	    x = ((float) x1) + slope * (y - y1);
	    }
	dx = ((float) xp) - x;
	dy = ((float) yp) - y;
	D2 = dx * dx + dy * dy;
	return(D2 < dist2);
	}
