#include <stdio.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <sys/stat.h>
#include <errno.h>
#include "tool.h"
#include "g.h"
#include "state.h"
#include "ext.h"


load_graph_from_file(g, fd)
struct GRAPH	*g;
FILE 		*fd;
{
	int  	 i, n, j, first, last, in, out, next, nl, ns, nd, nrp, ni;
	struct g_node *node;
	struct g_link *link;
	struct g_rspt *rspt;
	struct g_label *label;
	char buf[200];

	fscanf(fd, "%d\n", &g->type);
	if (g->type != PG) { 
		put_text("It is not a machine graph!"); 
		return; 
	}
	fscanf(fd, "%d %d %d %d\n", &g->node_no, &g->link_no, &g->rspt_no, &g->label_no);
	g->node_array = (struct g_node **) malloc(g->node_no*sizeof(struct g_node *)+1);
	g->link_array = (struct g_link **) malloc(g->link_no*sizeof(struct g_link *)+1);
	g->rspt_array = (struct g_rspt **) malloc(g->rspt_no*sizeof(struct g_rspt *)+1);
	g->label_array = (struct g_label **) malloc(g->label_no*sizeof(struct g_label *)+1);
	*g->node_array = (struct g_node *) NULL;
	for (i = 1; i <= g->node_no; i++)
		*(g->node_array+i) = (struct g_node *) malloc(G_NODE_SIZE);
	*g->link_array = (struct g_link *) NULL;
	for (i = 1; i <= g->link_no; i++)
		*(g->link_array+i) = (struct g_link *) malloc(G_LINK_SIZE);
	*g->rspt_array = (struct g_rspt *) NULL;
	for (i = 1; i <= g->rspt_no; i++)
		*(g->rspt_array+i) = (struct g_rspt *) malloc(G_RSPT_SIZE);
	*g->label_array = (struct g_label *) NULL;
	for (i = 1; i <= g->label_no; i++)
		*(g->label_array+i) = (struct g_label *) malloc(G_LABEL_SIZE);
	fscanf(fd, "first_node->no = %d\n", &first);
	g->first_node = *(g->node_array+first);
	fscanf(fd, "initial node no. = %d\n", &n);
	g->initial_node = *(g->node_array+n);
	for (i = 1; i <= g->node_no; i++) {
		fscanf(fd, "%d", &n);
		node = *(g->node_array+n);
		node->no = n;
		fscanf(fd, "%d %d %d %d %d %d %d %d ",
		&node->ssno, &node->x, &node->y, &node->reachable,
		&in, &out, &next, &j);
		if (j != 0) {
			fgets(buf, NAME_LENGTH, fd);
			n = strlen(buf) - 1;
			buf[n] = (char) 0;
		} else {
			n = 1;
			buf[0] = (char) 0;
			}
		node->label = (char *) malloc(n*sizeof(char));
		strcpy(node->label, buf);
		node->inlink = *(g->link_array+in);
		node->outlink = *(g->link_array+out);
		node->next = *(g->node_array+next);
	}

	fscanf(fd, "first_link->no = %d, last_link->no = %d\n", &first, &last);
	printf(fd, "first_link->no = %d, last_link->no = %d\n", &first, &last);
	g->first_link = *(g->link_array+first);
	g->last_link = *(g->link_array+last);
	for (i = 1; i <=  g->link_no; i++) {
		fscanf(fd, "%d ", &n);
		link = *(g->link_array+n);
		link->no = n;
		fscanf(fd, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",
		&link->type, &link->arcno, &link->channel_type, &link->src_port.x, &link->src_port.y,
		&ns, &link->dst_port.x, &link->dst_port.y, 
		&nd, &nl, &nrp, &in, &out, &next);
		link->src_port.node = *(g->node_array+ns);
		link->dst_port.node = *(g->node_array+nd);
		link->label = *(g->label_array+nl);
		link->rest_points = *(g->rspt_array+nrp);
		link->inlink = *(g->link_array+in);
		link->outlink = *(g->link_array+out);
		link->next = *(g->link_array+next);
	}
	fscanf(fd, "first_rspt->no = %d\n", &first);
	g->first_rspt = *(g->rspt_array+first);
	for (i = 1; i <= g->rspt_no; i++) {
		fscanf(fd, "%d ", &n);
		rspt = *(g->rspt_array+n);
		rspt->no = n;
		fscanf(fd, "%d %d %d %d %d\n",
		&rspt->x, &rspt->y, &nl, &ni, &next);
		rspt->link = *(g->link_array+nl);
		rspt->next_inlink = *(g->rspt_array+ni);
		rspt->next = *(g->rspt_array+next);
	}
	fscanf(fd, "first_label->no = %d\n", &first);
	g->first_label = *(g->label_array+first);
	for (i = 1; i <= g->label_no; i++) {
		fscanf(fd, "%d ", &n);
		label = *(g->label_array+n);
		label->no =n;
		fscanf(fd, "%d %d %d %d %c %d %d %d ",
		&label->x, &label->y, &label->w, &label->h,
		&label->abn, &nl, &next, &j);
		if (j != 0) {
			fgets(buf, LABELNAME_LENGTH, fd);
			n = strlen(buf) - 1;
			buf[n] = (char) 0;
		} else {
			n = 1;
			buf[0] = (char) 0;
			}
		label->name = (char *) malloc(n*sizeof(char));
		strcpy(label->name, buf);
		label->link = *(g->link_array+nl);
		label->next = *(g->label_array+next);
	}
	fprintf(fd, "***\n");
	free(g->node_array);
	free(g->link_array);
	free(g->rspt_array);
	free(g->label_array);
}
load_machine_from_RG_file(g, fd)
struct GRAPH	*g;
FILE 		*fd;
{
	int  	 i, n, j, first, last, in, out, next, nl, ns, nd, nrp, ni;
	struct g_node *node;
	struct g_link *link;
	struct g_rspt *rspt;
	struct g_label *label;
	char buf[200];
	int exact_node_no, exact_link_no, exact_rspt_no, exact_label_no;

	fscanf(fd, "%d\n", &g->type);
	if (g->type != PG) { 
		put_text("It is not a machine graph!"); 
		return; 
	}
	fscanf(fd, "%d %d %d %d\n", &g->node_no, &g->link_no, &g->rspt_no, &g->label_no);
	g->node_array = (struct g_node **) malloc(g->node_no*sizeof(struct g_node *)+1);
	g->link_array = (struct g_link **) malloc(g->link_no*sizeof(struct g_link *)+1);
	g->rspt_array = (struct g_rspt **) malloc(g->rspt_no*sizeof(struct g_rspt *)+1);
	g->label_array = (struct g_label **) malloc(g->label_no*sizeof(struct g_label *)+1);
	*g->node_array = (struct g_node *) NULL;
	for (i = 1; i <= g->node_no; i++)
		*(g->node_array+i) = (struct g_node *) malloc(G_NODE_SIZE);
	*g->link_array = (struct g_link *) NULL;
	for (i = 1; i <= g->link_no; i++)
		*(g->link_array+i) = (struct g_link *) malloc(G_LINK_SIZE);
	*g->rspt_array = (struct g_rspt *) NULL;
	for (i = 1; i <= g->rspt_no; i++)
		*(g->rspt_array+i) = (struct g_rspt *) malloc(G_RSPT_SIZE);
	*g->label_array = (struct g_label *) NULL;
	for (i = 1; i <= g->label_no; i++)
		*(g->label_array+i) = (struct g_label *) malloc(G_LABEL_SIZE);
	fscanf(fd, "exact_node_no = %d\n", &exact_node_no);
	fscanf(fd, "exact_link_no = %d\n", &exact_link_no);
	fscanf(fd, "exact_rspt_no = %d\n", &exact_rspt_no);
	fscanf(fd, "exact_label_no = %d\n", &exact_label_no);
	fscanf(fd, "first_node->no = %d\n", &first);
	g->first_node = *(g->node_array+first);
	fscanf(fd, "initial node no. = %d\n", &n);
	g->initial_node = *(g->node_array+n);
	for (i = 1; i <= exact_node_no; i++) {
		fscanf(fd, "%d", &n);
		node = *(g->node_array+n);
		node->no = n;
		fscanf(fd, "%d %d %d %d %d %d %d %d ",
		&node->ssno, &node->x, &node->y, &node->reachable,
		&in, &out, &next, &j);
		if (j != 0) {
			fgets(buf, NAME_LENGTH, fd);
			n = strlen(buf) - 1;
			buf[n] = (char) 0;
		} else {
			n = 1;
			buf[0] = (char) 0;
			}
		node->label = (char *) malloc(n*sizeof(char));
		strcpy(node->label, buf);
		node->inlink = *(g->link_array+in);
		node->outlink = *(g->link_array+out);
		node->next = *(g->node_array+next);
	}

	fscanf(fd, "first_link->no = %d, last_link->no = %d\n", &first, &last);
	g->first_link = *(g->link_array+first);
	g->last_link = *(g->link_array+last);
	for (i = 1; i <=  exact_link_no; i++) {
		fscanf(fd, "%d ", &n);
		link = *(g->link_array+n);
		link->no = n;
		fscanf(fd, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",
		&link->type, &link->arcno, &link->channel_type, &link->src_port.x, &link->src_port.y,
		&ns, &link->dst_port.x, &link->dst_port.y, 
		&nd, &nl, &nrp, &in, &out, &next);
		link->src_port.node = *(g->node_array+ns);
		link->dst_port.node = *(g->node_array+nd);
		link->label = *(g->label_array+nl);
		link->rest_points = *(g->rspt_array+nrp);
		link->inlink = *(g->link_array+in);
		link->outlink = *(g->link_array+out);
		link->next = *(g->link_array+next);
	}
	fscanf(fd, "first_rspt->no = %d\n", &first);
	g->first_rspt = *(g->rspt_array+first);
	for (i = 1; i <= exact_rspt_no; i++) {
		fscanf(fd, "%d ", &n);
		rspt = *(g->rspt_array+n);
		rspt->no = n;
		fscanf(fd, "%d %d %d %d %d\n",
		&rspt->x, &rspt->y, &nl, &ni, &next);
		rspt->link = *(g->link_array+nl);
		rspt->next_inlink = *(g->rspt_array+ni);
		rspt->next = *(g->rspt_array+next);
	}
	fscanf(fd, "first_label->no = %d\n", &first);
	g->first_label = *(g->label_array+first);
	for (i = 1; i <= exact_label_no; i++) {
		fscanf(fd, "%d ", &n);
		label = *(g->label_array+n);
		label->no =n;
		fscanf(fd, "%d %d %d %d %c %d %d %d ",
		&label->x, &label->y, &label->w, &label->h,
		&label->abn, &nl, &next, &j);
		if (j != 0) {
			fgets(buf, LABELNAME_LENGTH, fd);
			n = strlen(buf) - 1;
			buf[n] = (char) 0;
		} else {
			n = 1;
			buf[0] = (char) 0;
			}
		label->name = (char *) malloc(n*sizeof(char));
		strcpy(label->name, buf);
		label->link = *(g->link_array+nl);
		label->next = *(g->label_array+next);
	}
	fprintf(fd, "***\n");
	free(g->node_array);
	free(g->link_array);
	free(g->rspt_array);
	free(g->label_array);
}

save_machine_to_RG_file(g, fd)
struct GRAPH    *g;
FILE            *fd;
{
	short	 i;
	char 	buf1[200];

	/*******************************************************

		NO GARBAGE COLLECTION when saving system status
		since the ss[ssno].pn[1] field, which stores the node no
		should not be changeed, otherwise when we load RG back
		this field will have the wrong node no. (old one).

	*******************************************************/
	fprintf(fd, "%d\n", PG);

	fprintf(fd, "%d %d %d %d\n", g->node_no, g->link_no, g->rspt_no, g->label_no);
	for (node = g->first_node, i = 0; node != NULL; i++, node = node->next);
	fprintf(fd, "exact_node_no = %d\n", i);
	for (link = g->first_link, i = 0; link != NULL; i++, link = link->next);
	fprintf(fd, "exact_link_no = %d\n", i);
	for (rspt = g->first_rspt, i = 0; rspt != NULL; i++, rspt = rspt->next);
	fprintf(fd, "exact_rspt_no = %d\n", i);
	for (label = g->first_label, i = 0; label != NULL; i++, label = label->next);
	fprintf(fd, "exact_label_no = %d\n", i);
	fprintf(fd, "first_node->no = %d\n", 
		(g->first_node == (struct g_node *) NULL) ? 0 : g->first_node->no);
	fprintf(fd, "initial node no. = %d\n", 
		(g->initial_node == (struct g_node *) NULL) ? 0 : g->initial_node->no);

	for (node = g->first_node; node !=(struct g_node *) NULL; node = node->next)
		fprintf(fd, "%d 0 %d %d 0 %d %d %d %d %s\n",
			node->no, node->x, node->y, 
			(node->inlink == (struct g_link *) NULL) ? 
				0 : node->inlink->no, 
			(node->outlink == (struct g_link *) NULL) ? 
				0 : node->outlink->no, 
			(node->next == (struct g_node *) NULL) ? 
				0 : node->next->no,
			strlen(node->label),
			node->label);

	fprintf(fd, "first_link->no = %d, last_link->no = %d\n",  
		(g->first_link == (struct g_link *) NULL) ? 
			0 : g->first_link->no,
		(g->last_link == (struct g_link *) NULL) ? 
			0 : g->last_link->no);
	for (link = g->first_link; link != (struct g_link *) NULL; link = link->next)
		fprintf(fd, "%d %d 0 %d %d %d %d %d %d %d %d %d %d %d %d\n",
			link->no, 
			link->type, link->channel_type, 
			link->src_port.x, link->src_port.y,
			link->src_port.node->no, 
			link->dst_port.x,  link->dst_port.y, 
			link->dst_port.node->no,
			(link->label == (struct g_label *) NULL) ? 
				0 : link->label->no, 
			(link->rest_points == (struct g_rspt *) NULL) ? 
				0 : link->rest_points->no,
			(link->inlink == (struct g_link *) NULL) ? 
				0 : link->inlink->no, 
			(link->outlink == (struct g_link *) NULL) ? 
				0 : link->outlink->no,
			(link->next == (struct g_link *) NULL) ? 
				0 : link->next->no);
	fprintf(fd, "first_rspt->no = %d\n", 
		(g->first_rspt == (struct g_rspt *) NULL) ? 
			0 : g->first_rspt->no);
	for (rspt = g->first_rspt; rspt != (struct g_rspt *) NULL; rspt = rspt->next)
		fprintf(fd,"%d %d %d %d %d %d\n",
			rspt->no, 
			rspt->x, rspt->y, rspt->link->no,
			(rspt->next_inlink == (struct g_rspt *) NULL) ? 
				0 : rspt->next_inlink->no, 
			(rspt->next == (struct g_rspt *) NULL) ? 
				0 : rspt->next->no);

	fprintf(fd, "first_label->no = %d\n",
		(g->first_label == (struct g_label *) NULL) ? 
			0 : g->first_label->no);
	for (label = g->first_label; label != (struct g_label *) NULL; label = label->next)
		fprintf(fd, "%d %d %d %d %d _ %d %d %d %s\n",
			label->no, 
			label->x, label->y, label->w, label->h,
			(label->link == (struct g_link *) NULL) ? 
				0 : label->link->no,
			(label->next == (struct g_label *) NULL) ? 
				0 : label->next->no,
			strlen(label->name),
			label->name);	 

	fprintf(fd, "***\n");
	return;
}
