.TH setool 3 "14 September 1992" "State Exploration Tool" "PROSPEC Reference Manual"
.SH NAME
setool \- State Exploration Tool
.SH SYNOPSIS
.B setool
.SH DESCRIPTION
Setool is a protocol design tool that lets you create and edit Communicating 
Finite State Machines, CFSMs, made
up of nodes, edges, node labels, edge labels, and initial nodes.
It allows you to create a two-machine protocol by specifying the file names 
of individual CFSMs.
It performs interactive reachability analysis on a protocol,
shows the reachability graph, highlights the potential error states, and shows
the path to a global state.  It allows you to explore the reachability graph
of a specified depth from a selected global state, 
therefore allows you to control the
state exploration process interactively.

Setool displays a CFSM or reachability graph 
in its \fIcanvas area\fP.  On top of the canvas area
is a set of \fIsetool\fP pull-down menu buttons and panel choice buttons, 
and above the panel buttons
is the \fIstatus subwindow\fP which displays status or guidance 
information. 
.SH "MACHINE EDITING TOOLS"
There are several tools in the pull-down 
.B Machine 
menu to facilitate the editing of
a CFSM.
You must engage a tool before you can use it.  You engage a tool by
selecting the corresponding menuitem in the Machine menu. 
Once engaged, the status subwindow will show guidance messages on 
how to use the tool.  The convention is to use the left mouse button for 
pointing your selection of nodes, edges, or locations, to use the middle button
for adjusting or concluding an action, to use the right mouse button to pop
up the menu and select menuitems.

The
.BR "create machine" ,
.BR "load machine" ,
and
.B save machine
tools pop up a frame and ask for the file name of the CFSM for 
storage and retrieval.
The file name of a CFSM is <protocol name>.<machine name>. 
It consists of the protocol name, followed by the period, 
followed by the machine name.
The same file name is used to identify a machine in the system.
Inside the popup frame, you have to fill out both the protocol name
and the machine name.  You conclude the specification by pressing either 
the 
.BR "Do it" ,
or 
.BR "Cancel it" 
button.
.TP 15
.B create machine
Destroy the current CFSM and replace with a new blank CFSM.
.TP 15
.B load machine
Retrieve the CFSM from the current working directory, display it, and make it the current CFSM.
.TP 15
.B save machine
Save the current CFSM to a file using the full machine name.
.PP
The
.BR "place node" ,
.BR "move node" ,
.BR "remove node" ,
.BR "change initial node" ,
and 
.B change node label
tools
create and manipulate nodes.
.TP 15
.B place node
Create a node by pointing to the 
location of the node.  
.TP 15
.B move node
Move a node by pointing to the node, letting go the left button, 
moving the mouse cursor
to the new location, and finally clicking the middle button on the new location.
Note that the incoming and outgoing edges of the node will also move.
.TP 15
.B remove node
Just point to the node to be removed.
.TP 15
.B change initial node
Point to the new initial node.  The initial node symbol will be displayed on
top of the new initial node.  It may get messy on the original initial node.
Try use
.B redisplay
menuitem to make the display clean.
.TP 15
.B change node label
Popup a frame to ask for the new node label.
.PP
The
.BR "place edge" ,
.BR "move edge" ,
.BR "remove edge" ,
and 
.B change edge label
create and manipulate edges.
.TP 15
.B place edge
Point to the source node of the edge first, then point to intermediate points of the edge,
conclude by clicking the middle button on the destination node of the edge.  The
editing mode automatically changes to specifying the edge label, as it is 
indicated by the cursor, a square box with missing right edge.  Just type in
the edge or transition label (use displayable characters), followed by return key or the middle button.  
While you are typing in the edge label, you may drag (press down the left 
button) it to the right position.  For the edge that has the same node as the
source and destination node, i.e., a loop, try to put some intermediate points 
of the edge outside of the node.  
Press the left button followed directly by the middle button
on the node will be considered a null operation.
To distinguish two edges with the same source and destination nodes, arrange 
to let one of the edges contain intermediate points so that the two edges 
will not overlap.  Note that the leading + of the edge label represents the
receiving transition and the leading - (not the underscore _) 
represents the sending transition. Other types of labels will be considered as
internal transitions.
.TP 15
.B move edge
Point to the intermediate points of the edge to be moved or adjusted. 
Remember to let go the left button.  Move the cursor to the desired position.
Conclude the action by hitting the middle button.
.TP 15
.B remove edge
Point to the edge to be removed.
.TP 15
.B change edge label
Point to the edge label to be changed (either the location or the label content). 
Notice the cursor will be changed to the label cursor. Use the delete key to delete the last character of the label.  Use the ^u to erase the whole label.
Change the location by dragging (keeping the left button down while moving the mouse) the label to the new location.
Conclude the changes by hitting the middle button or the return key.
.PP
.BR "save subgraph" ,
.BR "place subgraph" ,
.BR "move subgraph" ,
and 
.B remove subgraph 
manipulate portion of the current CFSM.
.TP 15
.B save subgraph
Point to the upper-left and lower-right corners of the subgraph.  Enter the
file name of the subgraph for storage.
.TP 15
.B place subgraph
Enter the file name of the subgraph for retrieval.  Point to the location
where the subgraph will be placed.  The nodes and edges will be inserted to
the current CFSM.
.TP 15
.B move subgraph
Point to the upper-left and lower-right corners of the subgraph to be moved. 
Point to
the reference point then point to the new location.  Conclude by hitting the
middle button.
.TP 15
.B remove subgraph
Point to the upper-left and lower-right corners of the subgraph to be removed.
.TP 15
.B move machine
Point to
the reference point then point to the new location.  Conclude by hitting the
middle button.
.TP 15
.B change machine name
Popup a frame to ask for the new machine name.  This change only affect the
current  CFSM on the screen not on the machine in the file.  To change the
name of the CFSM you have to save the CFSM with a changed name, i.e.,
change the second part of the file name.
(Remember that the format of the file name is <protocol name>.<machine name>.)
.TP 15
.B redisplay
Redraw the current CFSM.
.SH "PROTOCOL VALIDATING TOOLS"
There are several tools in the pull-down 
.B Protocol 
menu to facilitate the creation and the state exploration of
a two-machine protocol.
You must engage a tool before you can use it.  You engage a tool by
selecting the corresponding menuitem in the Protocol menu. 
Once engaged, the status subwindow will show guidance messages on 
how to use the tool. 
.TP 15
.B create protocol
Pop up a frame and ask for the protocol name and the file names of the two
CFSMs.  Note that you have to enter the full file names.
Once you enter the specification, the information will be saved as a file
with the format <protocol name>.process.names and the two CFSMs will be displayed together with two channel symbols.
.TP 15
.B load protocol
Once you have created a protocol and save it as a file, you can load it back
by selecting this menuitem.  
.TP 15
.B show protocol
Redisplay the two CFSMs of the current protocol and the two channel symbols.
.TP 15
.B store protocol
Pop up a frame and ask for the protocol name to be used to store the current
protocol.
.TP 15
.B RG from initial state
Perform the reachability analysis on the current protocol starting from the 
initial global state, where the two CFSMs are in their initial nodes and both
channels empty.  A frame will be popuped and ask for the level (depth) of 
the state exploration.  Default is 8.  Enter the level and conclude by hitting
the 
.B Do it
or 
.B Cancel it
button.
After a few seconds the generated reachability graph will be displayed together
with the the message mapping table which shows the mapping of long mnemonic 
names of messages to single characters.
The size of the screen can be resized by hitting and dragging on the upper-right
resizing button of the window (I assume you are using twm.)
If the level is more than 8, the lower part of the reachability graph (RG) 
can be displayed by selecting the smaller zoom level in the zoom pull down 
menu or by selecting the 
.B move RG
menuitem in the
.B Protocol
menu to move the RG up.

Note that the upper-left  corner of the global state in the reachability graph shows
the global state number. The left (right) corner number represents the current node of
the left (right) CFSM and the string on top of (below) the channel symbol 
represents the input channel content of the right (left) CFSM.
The upper-right corner character indicates the type of errors or potential
error states.  Here Character 
.B U 
represents 
.B unspecified reception
errors.
Character 
.B D
represents
.BR deadlock .
.B P
represents
.BR "proper termination" .
The error states together with those that are yet to be explored will be 
highlighted.
.TP 15
.B RG from specific state
Point to the unexplored global state to be further explored.  Enter the
state exploration depth in the popup frame. Point to the location where
the new RG should be displayed.   You can select the 
.B
show RG
menuitem to show how current reachability graph expands.
.TP 15
.B show path to specific state
Show the path from initial global state to a specific state in the reachability
graph by pointing at the specific state.  Point at the location for displaying
the path.
.TP 15
.B show detail
This displays the two CFSMs and the channel symbols.  You can then click 
on the global state or transition in the path or RG.  The state or the
transition will be highlighted so are the corresponding nodes in the two
CFSMs and the channel contents will be displayed inside the channel symbols.
It allows one to understand better how the protocol reaches certain state.
.TP 15
.B show RG
Redisplay the current reachability graph.
.TP 15
.B show message table
Redisplay the message mapping table,
which shows the mapping of long mnemonic
names of messages to single characters.
.TP 15
.B move RG
Point to a reference point and then point to the new location of the 
reference point.  The RG will be displayed in the new location.
.TP 15
.B store RG to file
Store the current RG to a file.
.TP 15
.B load RG from file
Remove the current RG and load a RG from a file.
.TP 15
.B redisplay
Same as show RG.
.TP 15
.B Exit to Edit Machine
Specify which of the two CFSMs to be edited.
The selected CFSM will be displayed.
.SH Other Menus and Panel Choice Buttons
The 
.B Zoom
menu allows the selection of 5 zoom levels for a CFSM, from 1 to 1/16, and
allow only 4 zoom levels for the RG, from 1 to 1/8.
After selecting the zoom level, point to the location where the graph is
to be displayed.
.PP
The 
.B Comment
menu allows the creation and manipulation of comment labels, which enable 
you to document the CFSM or RG better.  Their operations are similar to those
on edge labels.
.PP
The 
.B Edge Type
menu provides the selection of different edge drawing style: 
Tension-spline, Beta-spline, and straight line.  The Tension-spline passes
through all the intermediate points while the Beta-spline does not.  The 
spline drawing is computation intensive and for better display quality.
.PP
The 
.B arrow head
panel choice buttons allow the selection of solid, spear, or no arrow head.
The  selection of the 
.B fast
draw panel choice button redisplays the edges as straight lines (disables the 
spline drawing and makes the drawing fast.)
The selection of the 
.B delicately
draw panel choice button enables spline drawing and redisplays the graph.
.TP 15
.B Print
Print the any of the X windows on the screen.  The cursor will be changed to
a cross. Move the cross cursor to the canvas window and hit the mouse button.
The bell will sound to confirm the completion of the screendump.  The default
ps laser printer is used.  This is hard-coded in a system call,
system("xwd | xpr -device ps | lpr -Pps"), in main.c.
.PP
The 
.B Quit
panel button asks you to confirm the exit of the setool.
.SH KNOWN BUGS and Hints
If you did not type in displayable characters while specifying the edge label,
there is no way to change the edge label.
You may remove the edge and specify it again.
This kind of edges may result in the failure of the reachability analysis 
procedure.
Try to remove standalone nodes.
The current graphic contexts for drawing and erase node symbols work partially
for the black and white monitor and  does not work on the color monitor.
The moving operations on edges and nodes may leave dirty mark due to the 
improper graphic context.  Use redisplay menuitem to make the screen clean again.
Send bug reports or suggestions to chow@quandary.uccs.edu
