#include <stdio.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include "tool.h"
#include "menu.h"
#include "g.h"
#include "state.h"
#include "ext.h"
#include "extxv.h"

Menu menu1;
Menu menu2;
Menu edit_menu;

redisplay_proc()
{

    paint_canvas();
    if (g == 0) return;
    draw_graph();
}

void
PLACE_NODE_proc(item, event)
Menu_item item;
Event *event;
{
	mode = PLACE_NODE;
	put_text_high("Hit left button for new node; correct position by moving mouse;");
	put_text(" hit left button again to confirm position; middle button : cancel.");
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, node_cursor, 0);
}

void
MOVE_NODE_proc(item, event)
Menu_item item;
Event *event;
{
	mode = MOVE_NODE;
	put_text("Please point to the node to be moved .");
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, node_cursor, 0);
}

void
REMOVE_NODE_proc(item, event)
Menu_item item;
Event *event;
{
	mode = REMOVE_NODE;
	put_text("Please point to the node to be removed .");
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, node_cursor, 0);
}

void
CHANGE_NODE_LABEL_proc(item, event)
Menu_item item;
Event *event;
{
	mode = CHANGE_NODE_LABEL;
	put_text("Please point to the node label to be changed.");
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, node_cursor, 0);
}

void
CHANGE_INITIAL_NODE_proc(item, event)
Menu_item item;
Event *event;
{
	mode = CHANGE_INITIAL_NODE;
	put_text("Please point to the new initial node.");
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, node_cursor, 0);
}

void
PLACE_LINK_proc(item, event)
Menu_item item;
Event *event;
{
	mode = PLACE_LINK;
	link_type = T_SPLINE; /* default */
	channel_type = UNI_DIRECTIONAL; /* default */
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, link_cursor, 0);
	put_text("Please select the type of the edge in the Edge Type menu.");
	put_text_higher("Please point out the source node of the edge.");
}

void
MOVE_LINK_proc(item, event)
Menu_item item;
Event *event;
{
	mode = MOVE_LINK;
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, link_cursor, 0);
	put_text("Please point to the edge whose intermediate point to be moved.");
}

void
REMOVE_LINK_proc(item, event)
Menu_item item;
Event *event;
{
	mode = REMOVE_LINK;
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, link_cursor, 0);
	put_text("Please point to the edge to be removed .");
}

void
CHANGE_LINK_LABEL_proc(item, event)
Menu_item item;
Event *event;
{
	mode = CHANGE_LINK_LABEL;
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, link_cursor, 0);
	put_text("Please point to the edge label or the edge.");
}

void
SAVE_SUB_GRAPH_proc(item, event)
Menu_item item;
Event *event;
{
	mode = SAVE_SUB_GRAPH;
	strcpy(askname, "Enter the protocol name of the sub-graph : ");
	strcpy(name, "test");
	nameptr = strlen(name) - 1;
	namelength = NAME_LENGTH;
	sw = READING_PROTOCOL_NAME;
	write_text(askname, name);
	canvas_reader = name_reader;
}

void
PLACE_SUB_GRAPH_proc(item, event)
Menu_item item;
Event *event;
{
	mode = PLACE_SUB_GRAPH;
	strcpy(askname, "Enter the protocol name of the graph : ");
	strcpy(name, "test");
	nameptr = strlen(name)-1;
	namelength = PROTOCOL_NAME_LENGTH;
	sw = READING_PROTOCOL_NAME;
	write_text(askname, name);
	canvas_reader = name_reader;
}

void
MOVE_SUB_GRAPH_proc(item, event)
Menu_item item;
Event *event;
{
	mode = MOVE_SUB_GRAPH;
	put_text("Please point to the upper left conner of the sub-graph to be removed."); 
}

void
REMOVE_SUB_GRAPH_proc(item, event)
Menu_item item;
Event *event;
{
	mode = REMOVE_SUB_GRAPH;
	put_text("Please point to the upper left conner of the sub-graph to be removed.");
}

void
CREATE_GRAPH_proc(item, event)
Menu_item item;
Event *event;
{
	int result;

	clear_msg();
	mode = CREATE_GRAPH;
	if (g->status == MODIFIED) {
		result = notice_prompt(canvas, 0,
				NOTICE_MESSAGE_STRINGS, "Have you stored the current graph?", 
					"Create new graph will destroy the current graph.", 0,
                NOTICE_BUTTON_YES, "Go ahead with the creation",
                NOTICE_BUTTON_NO, "Cancel the creation",
                0);			
		if (result == NOTICE_NO) return;
	}
	release_objects();
	paint_canvas();
	strcpy(askname, "Enter the protocol name of the new graph : ");
	strcpy(name, protocol_name);
	xv_set(popupMsg_item, PANEL_LABEL_STRING, 
		"Create Machine: Specify the full Machine name <protocol_name>.<machine_name>",
		0);
	strcpy(askname, "Please enter protocol_name:");
	strcpy(name, protocol_name);
	xv_set(popupData_item, PANEL_LABEL_STRING, askname, 
		PANEL_VALUE, name, 
		0);
	xv_set(popupData2_item,PANEL_LABEL_STRING, "Please enter machine_name:",
		PANEL_VALUE, "S", 
		XV_SHOW, TRUE,
		0);
	sw = CREATE_GRAPH;
	xv_set(subframe, XV_SHOW, TRUE, 0);
}


void
LOAD_GRAPH_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
	mode = LOAD_GRAPH;
	xv_set(popupMsg_item, PANEL_LABEL_STRING, 
		"Load Machine: Full Machine name is <protocol_name>.<machine_name>",
			0);
	strcpy(askname, "Please enter protocol_name:");
	strcpy(name, protocol_name);
	xv_set(popupData_item, PANEL_LABEL_STRING, askname, 
		PANEL_VALUE, name, 
		0);
	xv_set(popupData2_item, PANEL_LABEL_STRING, "Please enter machine_name:", 
		PANEL_VALUE, "S", 
		XV_SHOW, TRUE,
		0);
	sw = LOAD_GRAPH;
	xv_set(subframe, XV_SHOW, TRUE, 0);
}

void
STORE_GRAPH_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
	mode = STORE_GRAPH;
	xv_set(popupMsg_item, PANEL_LABEL_STRING, 
		"Save Machine: Full Machine name is <protocol_name>.<machine_name>",
			0);
	strcpy(askname, "Please enter protocol_name:");
	strcpy(name, protocol_name);
	xv_set(popupData_item, PANEL_LABEL_STRING, askname, 
		PANEL_VALUE, name, 
		0);
	xv_set(popupData2_item, PANEL_LABEL_STRING, "Please enter machine_name:", 
		PANEL_VALUE, "", 
		XV_SHOW, TRUE,
		0);
	sw = STORE_GRAPH;
	xv_set(subframe, XV_SHOW, TRUE, 0);
}

void
EDIT_ANOTHER_MACHINE_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
			mode = EDIT_MACHINE;
			if (g == P[1].g) {
				g = P[0].g;
				strcpy(name, P[0].name);
				if (machine_exist[0] == 0) {
					paint_canvas();
					DX = g->DX = 0; DY = g->DY = 0;
					draw_graph();
					}
				else {
					DX = g->DX; DY = g->DY;
					}
			} else {
				g = P[1].g;
				strcpy(name, P[1].name);
				if (machine_exist[1] == 0) {
					paint_canvas();
					DX = g->DX = 0; DY = g->DY = 0;
					draw_graph();
					}
				else {
					DX = g->DX; DY = g->DY;
					}
				}
			erase_machine_name();
			strcpy(askname, "Please correct the machine name : ");
			nameptr = strlen(name)-1;
			namelength = NAME_LENGTH;
			sw = READING_MACHINE_NAME;
			write_text(askname,name);
			canvas_reader = name_reader;
}

void
RETURN_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
	mode = ANALYZE;
	paint_canvas();
	clear_msg();
	put_text("Displaying the machines of the protocol");
	display_protocol();
	mode = MACHINE_EXIST;
	put_text_high("Select 'RG from initial state' to generate RG.");
	menu_selected = menu1_selected;
}

void
CLEAR_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
	mode = CLEAR; 
	release_graph();
	paint_canvas();
	clear_msg();
}

edit_menu_selected(ie)
Event *ie;
{
    Event *event;

	xv_set(edit_menu, 
		WIN_CMS_NAME, "palette",
		WIN_CMS_DATA, &cms_data,
		WIN_FOREGROUND_COLOR, 7,
		WIN_BACKGROUND_COLOR, 4,
		0);
	fprintf(stderr, "edit_menu_selected: enter\n");
    menu_show(edit_menu, canvas, event, 0);
	fprintf(stderr, "edit_menu_selected: after menu_show\n");
    reset_canvas_reader();
}

void
read_protocol_name()
{
	strcpy(askname, "Please enter protocol name:");
	strcpy(name, protocol_name);
	xv_set(popupData_item, PANEL_LABEL_STRING, askname, 
		PANEL_VALUE, name, 
		0);
	sw = REACHABILITY_ANALYSIS;
	xv_set(subframe, XV_SHOW, TRUE, 0);
}

void
CREATE_PROTOCOL_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
	mode = CREATE_PROTOCOL;
	xv_set(protocolFrame, XV_SHOW, TRUE, 0);
}

void
LOAD_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
	mode = LOAD;
	xv_set(popupMsg_item, PANEL_LABEL_STRING, "Load Protocol From File:",
		0);
	read_protocol_name();
}

void
STORE_proc(item, event)
Menu_item item;
Event *event;
{
	mode = STORE;
	read_protocol_name();
}

void
ANALYZE_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
	mode = ANALYZE;
	if (P[1].g->first_node == 0 || 
	    P[0].g->first_node == 0) {
		put_text("Empty Machine! Check Protocol please.");
		return;
		}
	strcpy(askname, "How deep (no. of levels) to explore? ");
	xv_set(popupData_item, PANEL_LABEL_STRING, askname, 
		PANEL_VALUE, "8", 
		0);
	sw = INIT;
	xv_set(subframe, XV_SHOW, TRUE, 0);
}

void
EDIT_MACHINE_proc(item, event)
Menu_item item;
Event *event;
{
	char buf[300];
	int result;

	clear_msg();
   	sprintf(buf, "Which machine of the protocol is to be edited?");
	result = notice_prompt(canvas, 0, 
				NOTICE_MESSAGE_STRINGS, buf, 0,
				NOTICE_BUTTON_YES, P[1].name,
				NOTICE_BUTTON_NO, P[0].name,
				0);
	switch(result) {
	case NOTICE_YES:
		g = P[1].g;
		DX = g->DX; DY = g->DY;
		strcpy(name, P[1].name);
		if (machine_exist[1] == 0) draw_graph();
		break;
	case NOTICE_NO:				
		g = P[0].g;
		DX = g->DX; DY = g->DY;
		strcpy(name, P[0].name);
		if (machine_exist[0] == 0) draw_graph();
		break;
	case NOTICE_FAILED:
		xv_set(msg_item, PANEL_LABEL_STRING, "unable to pop-up", 0);
		break;
	default:
		xv_set(msg_item, PANEL_LABEL_STRING, "unknown choice", 0);
	}
	xv_set(popupMsg_item, PANEL_LABEL_STRING, "Edit Machine:",
			0);
	strcpy(askname, "Please correct the machine name : ");
	xv_set(popupData_item, PANEL_LABEL_STRING, askname,
		PANEL_VALUE, name,
		0);
	xv_set(subframe, XV_SHOW, TRUE, 0);
	sw = READING_MACHINE_NAME;
	mode = EDIT_MACHINE;
}

void
EDIT_MACHINE_NAME_proc(item, event)
Menu_item item;
Event *event;
{
	char buf[300];
	int result;

	clear_msg();
	xv_set(popupMsg_item, PANEL_LABEL_STRING, "Change machine name:",
			0);
	strcpy(askname, "Please correct the machine name : ");
	xv_set(popupData_item, PANEL_LABEL_STRING, askname,
		PANEL_VALUE, name,
		0);
	xv_set(subframe, XV_SHOW, TRUE, 0);
	sw = READING_MACHINE_NAME;
	mode = EDIT_MACHINE;
}

void
MOVE_GRAPH_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
	mode = MOVE_GRAPH;
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, node_cursor, 0);
	put_text("Please point to the reference point.");
}

void
PRINT_MSGTBL_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
	print_msg_table();
}

void
SHOW_PROTOCOL_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
	mode = SHOW_PROTOCOL;
	paint_canvas();
	display_protocol();
}

void
REDISPLAY_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
	cur_cursor = (Xv_Cursor) xv_get(canvas_paint_window(canvas), WIN_CURSOR);
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, wait_cursor, 0);
	redisplay_proc();
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, cur_cursor, 0);
}

void
LOAD_RG_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
	mode = LOAD_RG;
	strcpy(askname, "Please enter the name of the RG : ");
	strcpy(name, "temp");
	nameptr = strlen(name) - 1;
	namelength = NAME_LENGTH;
	write_text(askname, name);
	sw = REACHABILITY_ANALYSIS;
	canvas_reader = name_reader;
	return;
}

void
STORE_RG_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
	mode = STORE_RG;
	if (rg[0]->g == 0) {
		put_text("RG not exists.");
		return;
		}
}

void
SHOW_RG_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
	mode = SHOW_RG;
	g = rg[0]->g;
	if (g->node_no == 0) return;
	DX = g->DX;
	DY = g->DY;
	put_text("Displaying the RG");
	show_rg();
}

void
EXPLORE_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
	mode = EXPLORE;
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, node_cursor, 0);
	put_text("Please click the state for further exploring.");
}

void
SHOW_PATH_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
	mode = SHOW_PATH;
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, node_cursor, 0);
	put_text("Please point to the end state of the path.");
}

void
DETAIL_proc(item, event)
Menu_item item;
Event *event;
{
	clear_msg();
	mode = DETAIL;
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, node_cursor, 0);
	put_text("Please point to the state to be detailed.");
}

void
T_SPLINE_proc(item, event)
Menu_item item;
Event *event;
{
	link_type = T_SPLINE;
}

void
B_SPLINE_proc(item, event)
Menu_item item;
Event *event;
{
	link_type = B_SPLINE;
}

void
LINE_proc(item, event)
Menu_item item;
Event *event;
{
	link_type = LINE;
}

void
ENTER_COMMENT_proc(item, event)
Menu_item item;
Event *event;
{
	mode = ENTER_COMMENT;
	reset_canvas_reader();
	clear_msg();
	put_text("Please point to the position for displaying comment.");
	xv_set(canvas_paint_window(canvas), WIN_CURSOR, link_cursor, 0);
}

void
CHANGE_COMMENT_proc(item, event)
Menu_item item;
Event *event;
{
	mode = CHANGE_COMMENT;
	reset_canvas_reader();
	clear_msg();
	put_text("Please point to the comment to be changed.");
	xv_set(canvas_paint_window(canvas),
		WIN_CURSOR, link_cursor,
		0);
}

void
REMOVE_COMMENT_proc(item, event)
Menu_item item;
Event *event;
{
	mode = REMOVE_COMMENT;
	reset_canvas_reader();
	clear_msg();
	put_text("Please point to the comment to be removed.");
	xv_set(canvas_paint_window(canvas),
		WIN_CURSOR, link_cursor,
		0);
	show_comment();
}

menu2_selected(ie )
Event *ie;
{
	Event *event;

	menu_selected = menu1_selected;
	reset_canvas_reader();
}


menu1_selected(ie)
Event *ie;
{

	xv_set(menu1, 
		WIN_CMS_NAME, "palette",
		WIN_CMS_DATA, &cms_data,
		WIN_FOREGROUND_COLOR, 7,
		WIN_BACKGROUND_COLOR, 4,
		0);
	fprintf(stderr, "menu1_selected: enter\n");
	if (g != 0) { 
		g->DX = DX;
		g->DY = DY;
	}
	menu_show(menu1, canvas, ie, 0);
	fprintf(stderr, "menu1_selected: after menu_show\n");
}	

set_tracker(ie)
Event *ie;
{

	fprintf(stderr, "set_tracker: enter\n");
	ie->ie_locx = zoom*ie->ie_locx - DX;
	ie->ie_locy = zoom*ie->ie_locy - DY;
	fprintf(stderr, "set_tracker: mode=\n", mode);
	switch(mode) {
		int ssno;

	case EXPLORE :
		if (init_nodemoving(ie)) return;
		if (ss[node->ssno].out != 0) {
			put_text("The state has been explored. Try other states.");
			reset_canvas_reader();
			return;
			}
		strcpy(askname, "How deep (no. of levels) to explore? ");
	    xv_set(popupData_item, PANEL_LABEL_STRING, askname,
   	    	PANEL_VALUE, "8",
   	    	0);
    	xv_set(subframe, XV_SHOW, TRUE, 0);
		sw = EXPL;
		return;
	case PLACERG :
		exploreRGn(ie);
		modified();
		break;
	case SHOW_PATH :
		if (init_nodemoving(ie)) return;
		mode = POS_PATH;
		put_text("Point the place where the path should be located.");
		modified();
		break;
	case POS_PATH :
		paint_canvas();
		show_path(node->ssno, 0, ie->ie_locy);
		modified();
		break;
	case DETAIL :
		init_nodemoving(ie);
		display_protocol();
		if (node == 0) {
			link = link_search(ie->ie_locx, ie->ie_locy);
			if (link == 0) return;
			highlight_arc_and_link(link);
			link_highlighted = link;
		} else {
			highlight_state_and_node(node);
			node_highlighted = node;
		}
		put_text("Hit middle button to exit.");
		canvas_reader = detail_state_reader;
		return;
	case PLACE_NODE :
		init_nodetracking(ie);
		canvas_reader = node_tracker; 
		return;
	case PLACE_LINK :
		menu_selected = edit_menu_selected;
		if (init_linktracking(ie) == 0) return;
		canvas_reader = link_tracker;
		return;
	case SAVE_SUB_GRAPH :
	case MOVE_SUB_GRAPH :
		init_area_reader(ie);
		canvas_reader = area_reader;
		return;
	case MOVE_GRAPH :
		cur_x = ie->ie_locx; cur_y = ie->ie_locy;
		paint_canvas();
		save_link_drawing_mode = link_drawing_mode;
		save_arrow_head_drawing_mode = arrow_head_drawing_mode;
		link_drawing_mode = FAST;
		arrow_head_drawing_mode = NO_ARROW_HEAD;
		draw_graph();
		oldDX = DX; oldDY = DY;
		fix_x = cur_x;
		fix_y = cur_y;
		X = fix_x;
		Y = fix_y;
		draw_arc(fix_x, fix_y, cur_x, cur_y);
		put_text_high("Now point to the new position of this reference point,");
		put_text(" or conclude by hitting the middle button; CNTL : cancel the operation.");
		canvas_reader = movegraph_tracker;
		return;
	case MOVE_NODE :
		if (init_nodemoving(ie)) return;
		fix_x = node->x;
		fix_y = node->y; /*save the old location */
		replace_links_with_straight_links(node);
		put_text_high("Now move the node to the new position;");
		put_text("  conclude by hitting middle button; hit CNTL_C to cancel the operation.");
		canvas_reader = movenode_tracker;
		return;
	case MOVE_LINK :
		if (init_linkmoving(ie)) return;
		if (link->rest_points == 0) return;
		erase_link(link);
		save_link_drawing_mode = link_drawing_mode;
		save_arrow_head_drawing_mode = arrow_head_drawing_mode;
		link_drawing_mode = FAST;
		arrow_head_drawing_mode = NO_ARROW_HEAD;
		draw_link(link);
		put_text_high("");
		put_text("Please point to the intermediate point to be moved.");
		canvas_reader = rest_point_reader;
		return;
	case REMOVE_SUB_GRAPH :
		init_area_reader(ie);
		canvas_reader = area_reader;
		return;
	case REMOVE_NODE :
		remove_node(ie->ie_locx, ie->ie_locy);
		return;
	case REMOVE_LINK :
		remove_link(ie->ie_locx, ie->ie_locy);
		return;
	case CHANGE_NODE_LABEL :
		init_change_node_label(ie);
		return;
	case CHANGE_INITIAL_NODE :
		init_change_initial_node(ie);
		return;
	case CHANGE_LINK_LABEL :
		put_text_high("");
		init_change_edge_label(ie);
		return;
	case ENTER_COMMENT :
		init_comment_reader(ie);
		return;
	case CHANGE_COMMENT :
		put_text_high("");
		init_change_comment(ie);
		return;
	case REMOVE_COMMENT :
		remove_comment(ie);
		return;
	default :
		break; 
	}	
	reset_canvas_reader();
}	


init_menu(){

	menu1 = xv_create(0, MENU,
		MENU_TITLE_ITEM, "State Exploration",
		MENU_ACTION_ITEM, "create protocol", CREATE_PROTOCOL_proc,
		MENU_ACTION_ITEM, "load protocol", LOAD_proc,
		MENU_ACTION_ITEM, "show protocol", SHOW_PROTOCOL_proc,
		MENU_ACTION_ITEM, "store protocol", STORE_proc, 
		MENU_ACTION_ITEM, "RG from initial state", ANALYZE_proc,
		MENU_ACTION_ITEM, "RG from specific state",	EXPLORE_proc,
		MENU_ACTION_ITEM, "show path to specific state", SHOW_PATH_proc,
		MENU_ACTION_ITEM, "show details", DETAIL_proc, 
		MENU_ACTION_ITEM, "show RG", SHOW_RG_proc, 
		MENU_ACTION_ITEM, "show message table", PRINT_MSGTBL_proc,
		MENU_ACTION_ITEM, "move RG", MOVE_GRAPH_proc, 
		MENU_ACTION_ITEM, "store RG to   file", STORE_RG_proc, 
		MENU_ACTION_ITEM, "load  RG from file", LOAD_RG_proc, 
		MENU_ACTION_ITEM, "redisplay", REDISPLAY_proc, 
		MENU_ACTION_ITEM, "Exit to Edit Machine", EDIT_MACHINE_proc, 
		/*
		WIN_CMS_NAME, "palette",
		WIN_CMS_DATA, &cms_data,
		*/
		WIN_FOREGROUND_COLOR, 0,
		WIN_BACKGROUND_COLOR, 4,
		0);
	
	menu2 = xv_create(0, MENU,
		MENU_TITLE_ITEM, "Edge Type",
		MENU_ACTION_ITEM,  "T-spline",	T_SPLINE_proc, 
		MENU_ACTION_ITEM,  "B-spline",	B_SPLINE_proc, 
		MENU_ACTION_ITEM,  "straight line", LINE_proc,
		/*
		WIN_CMS_NAME, "palette",
		WIN_CMS_DATA, &cms_data,
		*/
		WIN_FOREGROUND_COLOR, 0,
		WIN_BACKGROUND_COLOR, 4,
		0);
	
	edit_menu = xv_create(0, MENU,
		MENU_TITLE_ITEM, "Edit Machine",
		MENU_ACTION_ITEM, "create machine",   CREATE_GRAPH_proc,
		MENU_ACTION_ITEM, "load   machine",	LOAD_GRAPH_proc,
		MENU_ACTION_ITEM, "save  machine",	STORE_GRAPH_proc, 
		MENU_ACTION_ITEM, "place  node",	PLACE_NODE_proc,
		MENU_ACTION_ITEM, "move   node",	MOVE_NODE_proc,
		MENU_ACTION_ITEM, "remove node",	REMOVE_NODE_proc,
		MENU_ACTION_ITEM, "change node label", CHANGE_NODE_LABEL_proc,
		MENU_ACTION_ITEM, "change initial node",CHANGE_INITIAL_NODE_proc,
		MENU_ACTION_ITEM, "place  edge",	PLACE_LINK_proc,
		MENU_ACTION_ITEM, "move   edge",	MOVE_LINK_proc,
		MENU_ACTION_ITEM, "remove edge",	REMOVE_LINK_proc,
		MENU_ACTION_ITEM, "change edge label",	CHANGE_LINK_LABEL_proc,
		MENU_ACTION_ITEM, "save   subgraph",	SAVE_SUB_GRAPH_proc,
		MENU_ACTION_ITEM, "place  subgraph",	PLACE_SUB_GRAPH_proc ,
		MENU_ACTION_ITEM, "move   subgraph",	MOVE_SUB_GRAPH_proc ,
		MENU_ACTION_ITEM, "remove subgraph",	REMOVE_SUB_GRAPH_proc ,
		MENU_ACTION_ITEM, "move   machine",	MOVE_GRAPH_proc,
		MENU_ACTION_ITEM, "change machine name", EDIT_MACHINE_NAME_proc , 
		MENU_ACTION_ITEM, "edit another machine", EDIT_ANOTHER_MACHINE_proc , 
		MENU_ACTION_ITEM, "redisplay",	REDISPLAY_proc, 
		WIN_FOREGROUND_COLOR, 0,
		WIN_BACKGROUND_COLOR, 4,
		0);
}

