#include <stdio.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <sys/stat.h>
#include <errno.h>
#include "tool.h"
#include "g.h"
#include "state.h"
#include "ext.h"
#include "extxv.h"

/*
   usebit of the abb. name
   index 0 correspoding to '0' = (char) 48
        78                 '~' = (char) 126
   if the abb. char is used then abnuse[ (int)ch - 48 ] has value 1 otherwise 0

*/



char
msg_abb_name_resolution(m)
char m[];
{
	int  i,j;

	for (i = 0; (i < msgno + 1) && (strcmp(m, msgtbl[i].mes) != 0); i++) ;
	if (i == msgno + 1) {
		/* add a new entry to msgtbl */
	   strcpy(msgtbl[i].mes, m);
		/* decide the abb name */
	   /* check if the first char of m is duplicate with other
	      abb. name in the amsglst */
	   if (abnuse[ (int)m[0] - 48 ] == 0) {
		  /* not duplicate */
	      msgtbl[i].msg = m[0];
	      abnuse[(int)m[0] - 48] = 1;
	      msgno++;
	      return( m[0] );
	      }
	   /* find the first available abb name in msgtbl */
	   for (j = 0; j < 79; j++)
	       if (abnuse[j] == 0) {
		  msgtbl[i].msg = (char) (j + 48);
		  msgno++;
	    	  abnuse[j] = 1;
		  return(msgtbl[i].msg);
		  };
	   return((char) 32);
	   };
	/* found same message in msgtbl */
	return(msgtbl[i].msg);
}

print_msg_entry(line_no, line)
int line_no;
char line[];
{
	XDrawString(display, drawable, gcf, 800, line_no*16 + 20, 
				line, strlen(line));
}

print_msg_table()
{
	int i;
	char c, s[11];
	FILE *fd1, *fd2;
	struct  rect    rect, recticon;
	int line_no;
	char line[120];

	line_no = 0;
	fd1 = fopen("message_table", "w");
	for (i = 1; i <= msgno; i++) 
	    fprintf(fd1, "%c %s\n", msgtbl[i].msg, msgtbl[i].mes);

	fclose(fd1);
	system("sort  message_table > msgtbl");
	fd2 = fopen("msgtbl", "r");
	print_msg_entry(line_no++, "   message table");
	print_msg_entry(line_no++, "   -------------");
	print_msg_entry(line_no++, "abb. name  full name");
	print_msg_entry(line_no++, "=========  =========");
	while ((i=fscanf(fd2, "%c %s\n", &c, s)) != EOF && i != 0 ) {
	      sprintf(line, "%5c%6c%-10s", c, ' ', s);
	     print_msg_entry(line_no++, line);
	     }
	fclose(fd2);
}

save_msg_table(fd)
FILE *fd;
{
	int i;

	for (i = 0; i < 79; i++)
		fprintf(fd, "%d ", abnuse[i]);
	fprintf(fd, "\n");
	fprintf(fd, "%d\n", msgno);
	for (i = 1; i <= msgno; i++)
		fprintf(fd, "%c %s\n", msgtbl[i].msg, msgtbl[i].mes);
}

load_msg_table(fd)
FILE *fd;
{
	int i, n;

	for (i = 0; i < 79; i++) {
		fscanf(fd, "%d ", &n);
		abnuse[i] = (char) n;
		}
	fscanf(fd, "\n");
	fscanf(fd, "%d\n", &msgno);
	for (i = 1; i <= msgno; i++)
		fscanf(fd, "%c %s\n", &msgtbl[i].msg, msgtbl[i].mes);
}

