#include <stdio.h>
#include <xview/xview.h>
#include <xview/notice.h>
#include <sys/stat.h>
#include <errno.h>
#include <sys/file.h>
#include "tool.h"
#include "g.h"
#include "state.h"
#include "menu.h"
#include "ext.h"
#include "extxv.h"

#define F_OK    0   /* Test for existence of File */
/* on sun sparc the unistd.h has ext int link() declaration conflict with 
   the struct g_link *link declaration in ext.h 
   therefore we declare F_OK explictly here */

file_name_ok(name)
char name[];
{
	int accessible;
	int mode;
	int result;

	/* mode == F_OK is used for testing presence of file */ 
	accessible = access(name, F_OK); 
	if (accessible == 0) { /* same file name exists */
		result = notice_prompt(canvas, 0, 
				NOTICE_MESSAGE_STRINGS, 
					"The file already exists, overwrite it?",  0,
                NOTICE_BUTTON_YES, "Yes",
                NOTICE_BUTTON_NO, "No",
                0);
		if (result == NOTICE_YES) return(1);
		else return(0);
	}
	else return(1); /* file not exist and write operation is ok */
}

number_reader(ie) 
Event *ie; 
{	int i;
	
	if (win_inputnegevent(ie) ) {
		return;
	}
	if (ie->ie_code == CNTL_C) {
		clear_msg();
		put_text("Operation canceled !");
		reset_canvas_reader();
		}
	if ((ie->ie_code == CNTL_H) || (ie->ie_code == DEL))
 		if (noptr == -1) return;
		else {	
			no[noptr--] = ' ';
			write_text(askname,no);
			no[noptr+1] = (char) 0;
			return;
       		     }
 	if (ie->ie_code == CNTL_U) {
 		for ( ; -1 < noptr; )
			no[noptr--] = ' ';
		write_text(askname,no);
		no[0] = (char) 0;
		return;
 		}
 	if (ie->ie_code == CR || ie->ie_code == MS_MIDDLE) {
	   number = atoi(no);
	   clear_msg();
	   switch(sw) {
	      case INIT:
		  	paint_canvas(); 
			exploreRG0();
			sw = EXPL;
			reset_canvas_reader();
			return;
	      case EXPL:
			mode = PLACERG;
			xv_set(msg_item, PANEL_LABEL_STRING, 
			  "please point the place where the root of the RG should be.", 0);
			reset_canvas_reader();
			return;
	      }
	   }
	if (noptr > 1) return;
 	if ((ie->ie_code > 47) && (ie->ie_code < 58)) {
		no[++noptr] = (char) ie->ie_code;
		no[noptr+1] = (char) 0;
		write_text(askname,no);
		return;
		}
	if (ie->ie_code < 128) {
	put_text_high(" Only digits are allowed!");
	sleep(1);
	put_text_high(" ");
	return;
	}
}


name_reader(ie)
Event *ie;
{
	int i;
		
	if (win_inputnegevent(ie) ) {
		return;
	}
	if (ie->ie_code == CNTL_C) {
		clear_msg();
		put_text("Operation canceled !");
		reset_canvas_reader();
		}
 	if ((ie->ie_code == CNTL_H) || (ie->ie_code == DEL)) 
		if (nameptr == -1)  return;
		else {  
			name[nameptr--] = ' ';
			write_text(askname,name);
			name[nameptr+1] = (char) 0;
			return; 
		     }
   	if (ie->ie_code == CNTL_U) {
		for ( ; -1 < nameptr; )
			name[nameptr--] = ' ';
		write_text(askname,name);
		name[0]= (char) 0;      
		return;
		}
	if (nameptr > namelength) return;
 	if ((ie->ie_code > 31) && (ie->ie_code < 127)) {
		name[++nameptr] = (char) ie->ie_code;
		name[nameptr+1] = (char) 0;
		write_text(askname,name);
		return;
	}	
	if (ie->ie_code == CR || ie->ie_code == MS_MIDDLE) {
		switch(sw) {
		case READING_PROTOCOL_NAME:
			strcpy(protocol_name, name);
			strcpy(askname, "Enter the machine name : ");
			strcpy(name, process_name);
			nameptr = strlen(name)-1;
			namelength = PROTOCOL_NAME_LENGTH - 4;
			sw = READING_MACHINE_NAME;
			write_text(askname,name);
			return;
		case READING_MACHINE_NAME:
			strcpy(process_name, name);
			sprintf(file_name, "%s.%s", protocol_name, process_name);
			if (mode == LOAD) {
				release_objects();
				sprintf(buf, "Loading graph from %s", file_name);
				put_text_high(buf);
				load_file(file_name);
				
			} else if (mode == STORE) {
				if (file_name_ok(file_name) == 0) {
					reset_canvas_reader();
					return;
					}
				sprintf(buf, "Storing graph to %s", file_name);
				put_text_high(buf);
				store_file();
			} else if (mode == SAVE_SUB_GRAPH) {
				if (file_name_ok(file_name) == 0) {
					put_text("Please select the command in the middle button menu.");
					reset_canvas_reader();
					mode = 999;
					return;
					}
				put_text("Please point to the upper left conner of the sub-graph to be saved.");
				reset_canvas_reader();
				return;
				
			} else if (mode == CREATE_GRAPH) {
				if (file_name_ok(file_name) == 0) {
					reset_canvas_reader();
					return;
					}
			} else if (mode == PLACE_SUB_GRAPH) {
				canvas_reader = position_reader;
				put_text_high("Point to the upper left corner of the graph");
				put_text("  hit middle button for the upper left corner of the screen.");
				return;
			} else if (mode == EDIT_MACHINE) {
				if (g == P[0].g) strcpy(P[0].name, name);
				if (g == P[1].g) strcpy(P[1].name, name);
				draw_machine_name();
				}
			reset_canvas_reader();
			sleep(1);
			put_text_high("");
			return;
		case READING_NODE_LABEL :
			erase_node_label(node);
			free(node->label);
			i = strlen(name) + 1;
			node->label = node->label = (char *) malloc(i*sizeof(char));
			strcpy(node->label, name);
			write_node_label(node);
			reset_canvas_reader();
			put_text("Please point to the node whose label needs to be changed.");
			return;
		case REACHABILITY_ANALYSIS :
			if (mode == LOAD) {
				strcpy(protocol_name, name);
				load_protocol();
			}
			if (mode == STORE) {
				sprintf(buf, "%s.process.names", name);
				if (file_name_ok(buf) == 0) {
					reset_canvas_reader();
					return;
					}
				write_process_names(buf);
				write_machines(name);
				}
			if (mode == LOAD_RG) {
				strcat(name, ".rg");
				sprintf(buf, "Loading reachability graph to %s", name);
				put_text_high(buf);
				load_rg_from_file(name);	
				}
			if (mode == STORE_RG) {
				strcat(name, ".rg");
				if (file_name_ok(name) == 0) {
					reset_canvas_reader();
					return;
					}
				sprintf(buf, "Storing reachability graph to %s", name);	
				put_text_high(buf);
				store_rg_to_file(name);
				}
			reset_canvas_reader();
			sleep(1);
			put_text_high("");
			return;
		}
	}
}

write_process_names(filename)
char filename[];
{
	FILE *fd;

	fd = fopen(filename, "w");
	fprintf(fd, "%s\n", P[1].name);
	fprintf(fd, "%s\n", P[0].name);
	fclose(fd);
	}

write_machines(name)
char name[];
{
	FILE *fd;
	int i;

	for (i = 1; i > -1; i--) {
		sprintf(buf, "%s.%s", name, P[i].name);
		if (file_name_ok(buf) == 0) {
			reset_canvas_reader();
			return;  
			}
		fd = fopen(buf, "w");
		save_graph_to_file(P[i].g, fd);
		fclose(fd);
	}
}


	



