#include <stdio.h>
#include <xview/xview.h>
#include <xview/notice.h>
#include <sys/stat.h>
#include <errno.h>
#include "tool.h"
#include "g.h"
#include "state.h"
#include "ext.h"
#include "extxv.h"

save_rg(fd)
FILE *fd;
{
	int i, j;
	struct ARCLST *al;


	fprintf(fd, "name of M1 = %s\n", P[1].name);
	save_machine_to_RG_file(P[1].g, fd);
	fprintf(fd, "name of M2 = %s\n", P[0].name);
	save_machine_to_RG_file(P[0].g, fd);

	fprintf(fd, "No. of states = %d\n", cssno + 1);
	for (i = 0; i <= cssno; i++) {
		fprintf(fd, "ss %d:\n", i);
		for (j = 0; j <= 1; j++) 
			fprintf(fd, "%d %d %s\n", ss[i].pn[j], strlen(ss[i].c[j].m), ss[i].c[j].m);
		fprintf(fd, "%d %d %s\n", ss[i].parentarcno, strlen(ss[i].property), ss[i].property );
		for (j = 0, al = ss[i].in; al != 0; j++, al = al->next) ;
		fprintf(fd, "%d ", j);
		for (al = ss[i].in; al != 0; al = al->next)
			fprintf(fd, "%d ", al->arcno);
		fprintf(fd, "\n");
		for (j = 0, al = ss[i].out; al != 0; j++, al = al->next) ;
		fprintf(fd, "%d ", j);
		for (al = ss[i].out; al != 0; al = al->next)
			fprintf(fd, "%d ", al->arcno);
		fprintf(fd, "\n");
		}
	fprintf(fd, "No. of arcs = %d\n", arc_no + 1);
	for (i = 0; i <= arc_no; i++) 
		fprintf(fd, "arc %d: %d %d %s %d %d\n", i, arc[i].srcssno, arc[i].dstssno,
			arc[i].label, arc[i].processno, arc[i].edgeno);
	fprintf(fd, "***\n");
	save_msg_table(fd);
	fclose(fd);
}

load_rg(fd)
FILE *fd;
{
	int i, j, k;
	struct ARCLST *al;
	int arcno;

	g = P[1].g;
	release_objects();
	fscanf(fd, "name of M1 = %s\n", P[1].name);
	load_machine_from_RG_file(P[1].g, fd);
	g = P[0].g;
	release_objects();
	fscanf(fd, "name of M2 = %s\n", P[0].name);
	load_machine_from_RG_file(P[0].g, fd);
	fscanf(fd, "No. of states = %d\n", &cssno);
	cssno--;
	for (i = 0; i <= cssno; i++) {
		fscanf(fd, "ss %d:\n", &k);
		for (j = 0; j <= 1; j++) {
			fscanf(fd, "%h %d ", &(ss[i].pn[j]), &k);
			printf("ss[%d].pn[%d] = %d\n", i, j, ss[i].pn[j]);
			if (k == 0) {
				strcpy(ss[i].c[j].m, "");
				fscanf(fd, "\n"); 
				}
			else fscanf(fd, "%s\n", ss[i].c[j].m);
			printf("ss[%d].c[%d].m = %s\n", i, j, ss[i].c[j].m);
			}
		fscanf(fd, "%d %d ", &ss[i].parentarcno, &k);
		if (k == 0) {
			strcpy(ss[i].property, "");
			fscanf(fd, "\n");
			}
		else fscanf(fd, "%s\n", ss[i].property);
		printf("ss[%d].property = %s\n", i, ss[i].property);
		fscanf(fd, "%d ", &j);
		for (k = j; k > 0; k--) {
			fscanf(fd, "%d ", &arcno);
			appendarc(&(ss[i].in), arcno);
			}
		fscanf(fd, "\n");
		fscanf(fd, "%d ", &j);
		for (k = j; k > 0; k--) {
			fscanf(fd, "%d ", &arcno);
			appendarc(&(ss[i].out), arcno);
			}
		fscanf(fd, "\n");
		}
	fscanf(fd, "No. of arcs = %d\n", &arc_no);
	arc_no--;
	for (i = 0; i <= arc_no; i++) {
		fscanf(fd, "arc %d: ", &i);
		fscanf(fd, "%d %d %s %d %d\n", &arc[i].srcssno, &arc[i].dstssno,
			arc[i].label, &arc[i].processno, &arc[i].edgeno);
		}
	fscanf(fd, "***\n");
	load_msg_table(fd);
	fclose(fd);
}

release_arclst_in_ss()
{
	int i;
	struct ARCLST *al, *b;

	for (i = 0; i <= cssno; i++) {
		for (al = ss[i].in; al != 0; b = al, al = al->next, free(b));
		ss[i].in = 0;
		for (al = ss[i].out; al != 0; b = al, al = al->next, free(b));
		ss[i].out = 0;
		}
}
		

load_rg_from_file(filename)
char filename[];
{
	FILE *fd;
	int result;

	result = notice_prompt(canvas, 0, 
				NOTICE_MESSAGE_STRINGS, 
					"Have you stored the current RG?",  0,
                NOTICE_BUTTON_YES, "Proceed with load",
                NOTICE_BUTTON_NO, "Cancel the load",
                0);
	if (result == NOTICE_YES) {
			fd = fopen(filename, "r");
			if (fd == (FILE *) 0) {
					warning("Sorry, couldn't open %s",filename);
					return(1);
			}
			release_arclst_in_ss();
			load_rg(fd);
			show_rg();
			return(0);
	} else return(1);
}

store_rg_to_file(filename)
char filename[];
{
	FILE *fd;

	fd = fopen(filename, "w");
	save_rg(fd);
}
