#include <stdio.h>    /* this is where NULL is defined */
#include <xview/xview.h>
#include "tool.h"
#include "g.h"
#include "state.h"
#include "ext.h"

struct g_rspt *
rspt_search(x, y, res)
int	x, y, res;
{
	struct g_rspt	*p;
	int		 minx, maxx, miny, maxy;

	minx = x-res;
	maxx = x+res;
	miny = y-res;
	maxy = y+res;
	for (p = g->first_rspt; p != NULL; p = p->next) {
	    if (p->x < minx) continue;
	    if (p->x > maxx) return (NULL);
	    if (p->y < miny) continue;
	    if (p->y > maxy) continue;
	    return(p); 
	    }
	return(NULL);
	}

insert_rspt(p)
struct g_rspt	*p;
{
	register int	x, y;
	struct g_rspt	*q, *r;

	x = p->x;
	y = p->y;
	for (r = g->first_rspt; r != NULL; q = r, r = r->next) {
	    if (r->x > x) break;
	    if (r->x < x) continue;
	    if (r->y < y) continue;
	    if (r->y >= y) break;
	    }
	if (r == g->first_rspt) 
	    g->first_rspt = p;
	else
	    q->next = p;
	p->next = r;
	}

delete_rspt(p)
struct g_rspt	*p;
{
	struct g_rspt	*q, *r;

	if (g->first_rspt == NULL) return;
	if (p == NULL) return;
	for (r = g->first_rspt; r != NULL; q = r, r = r->next) {
	    if (r == p) {
		if (r == g->first_rspt)
		    g->first_rspt = p->next;
		else
		    q->next = p->next;
		return;
		}
	    }
	}

remove_restpt(link)
struct g_link	*link;
{
	struct g_rspt	*rest_point, *temp;
	int		 x, y;

	if (link->src_port.x == -1) {
	    x = link->rest_points->x;
	    y = link->rest_points->y;
	    rest_point  = link->rest_points->next_inlink;
	    delete_rspt(link->rest_points);
	    free(link->rest_points);
	    }
	else {
	    rest_point  = link->rest_points;
	    x = link->src_port.x;
	    y = link->src_port.y;
	    }

	while (rest_point != NULL) {
	/*
	    erase_vector(x, y, rest_point->x, rest_point->y);
	    */
	    x = rest_point->x;
	    y = rest_point->y;
	    temp = rest_point;
	    rest_point = temp->next_inlink;
	    delete_rspt(temp);
	    free(temp);
	    }
/*
	if (link->dst_port.x != -1) 
		erase_arc(x, y, link->dst_port.x, link->dst_port.y);
		*/
	}

