#include <stdio.h>
#include <xview/xview.h>
#include <sys/stat.h>
#include <errno.h>
#include "tool.h"
#include "g.h"
#include "state.h"
#include "ext.h"

release_state_list(sl)
struct STATELST *sl;
{
	struct STATELST *l;

	for (; sl != 0; l = sl, sl = sl->next, free(l)); 
	}

release_arc_list(al)
struct ARCLST *al; 
{ 
	struct ARCLST *l; 
		 
	for (; al != 0; l = al, al = al->next, free(l)); 
}

check_properties(sl)
struct STATELST *sl;
{
	struct STATELST *l;
	int ssno;

	for (l = sl; l != 0; l = l->next) {
		ssno = abs(l->ssno);
		if (ssno == 99999) ssno = 0;
		if (ss[ssno].property[0] == 'D') {
			append(&(rg[0]->deadlock), ssno);
			continue;
			}
		if (ss[ssno].property[0] == 'U') {
			append(&(rg[0]->unspecified_reception), ssno);
			continue;
			}
		if (ss[ssno].property[0] == 'P') {
			append(&(rg[0]->proper_termination), ssno);
			continue;
			}
		if (ss[ssno].out == 0) {
			append(&(rg[0]->unexpstatelst), ssno);
			continue;
			}
	}
}
		
show_rg()
{
	struct STATELST *sl, *srcstatelst, *dststatelst;
	struct ARCLST   *arclst;
	int depth, ssno;

	g = rg[0]->g;
	release_objects();
	release_state_list(rg[0]->deadlock);
	rg[0]->deadlock = 0;
	release_state_list(rg[0]->unspecified_reception);
	rg[0]->unspecified_reception = 0;
	release_state_list(rg[0]->proper_termination);
	rg[0]->proper_termination = 0;
	release_state_list(rg[0]->unexpstatelst);
	rg[0]->unexpstatelst = 0;
	g = rg[0]->g;
	DX = g->DX; DY = g->DY;
	init_g(g);
	paint_canvas();
	clear_msg();
	srcstatelst = 0;
	append(&srcstatelst, 0);
	draw_state_list(srcstatelst, 0);
	check_properties(srcstatelst);
	for (depth = 1; srcstatelst != 0; depth++) {
		/* generate arclst */
		outarclst = 0;
		for (sl = srcstatelst; sl != 0; sl = sl->next) {
			ssno = sl->ssno;
			if (ssno < 0) continue;
			for (arclst = ss[ssno].out; arclst != 0; arclst = arclst->next) 
				appendoutarc(arclst->arcno);
			}
		dststatelst = 0;
		for (arclst = outarclst; arclst != 0; arclst = arclst->next)
			append(&dststatelst, arc[arclst->arcno].dstssno);
		draw_state_list(dststatelst, depth);
		check_properties(dststatelst);
		draw_arc_list(outarclst, depth, srcstatelst, dststatelst);
		release_state_list(srcstatelst);
		srcstatelst = dststatelst;
		release_arc_list(outarclst);
		}
	highlight_error_states(0);
}
