#include <stdio.h>
#include <xview/xview.h>
#include <math.h>
#include "g.h"

#define				 INV_PAINT_OP		PIX_SRC ^ PIX_DST
#define				 round(x)		((int) (x + .5))

extern int               DX, DY;

op_spline(link, dore)
struct g_link	*link;
int dore;
{
	struct g_rspt	*p;
	float			 cx1, cy1, cx2, cy2, cx3, cy3, cx4, cy4;
	float			 x1, y1, x2, y2;

	if (link->rest_points == NULL) {
	   draw_arc(link->src_port.x, link->src_port.y, link->dst_port.x,
		  link->dst_port.y);
	   return;
	   }
	x1 = link->src_port.x;  y1 = link->src_port.y;
	p = link->rest_points;
	x2 =  p->x;  y2 =  p->y;
	cx1 = (x1 + x2) / 2;      cy1 = (y1 + y2) / 2;
	cx2 = (x1 + 3 * x2) / 4;  cy2 = (y1 + 3 * y2) / 4;
	pwVector((int)x1+DX, (int)y1+DY, round(cx1)+DX, round(cy1)+DY);

	for (p = p->next_inlink; p != (struct g_rspt *) NULL; p = p->next_inlink) {
	    x1 = x2;  y1 = y2;
	    x2 =  p->x;  y2 =  p->y;
	    cx3 = (3 * x1 + x2) / 4;  cy3 = (3 * y1 + y2) / 4;
	    cx4 = (x1 + x2) / 2;      cy4 = (y1 + y2) / 2;
	    chaikin_spline(cx1, cy1, cx2, cy2, cx3, cy3, cx4, cy4);
	    cx1 = cx4;  cy1 = cy4;
	    cx2 = (x1 + 3 * x2) / 4;  cy2 = (y1 + 3 * y2) / 4;
	    }
	x1 = x2; y1 = y2;
	x2 =  link->dst_port.x; y2 =  link->dst_port.y;
	cx3 = (3 * x1 + x2) / 4;  cy3 = (3 * y1 + y2) / 4;
	cx4 = (x1 + x2) / 2;      cy4 = (y1 + y2) / 2;
	chaikin_spline(cx1, cy1, cx2, cy2, cx3, cy3, cx4, cy4);
	cx1 = cx4;  cy1 = cy4;
	op_arc( round(cx1), round(cy1), (int)x2, (int)y2, dore);
}

chaikin_spline(x1, y1, x2, y2, x3, y3, x4, y4, dore)
float	x1, y1, x2, y2, x3, y3, x4, y4;
int	dore;
{
	float	xmid, ymid;

	xmid = (x2 + x3) / 2;  ymid = (y2 + y3) / 2;
	if (fabs(x1 - xmid) < 3 && fabs(y1 - ymid) < 3) {
	    pwVector(round(x1)+DX, round(y1)+DY, round(xmid)+DX, round(ymid)+DY);
	    }
	else {
	    chaikin_spline(x1, y1, 
			((x1 + x2) / 2),  ((y1 + y2) / 2),
			((3*x2 + x3) / 4), ((3*y2 + y3) / 4), xmid, ymid);
	    }

	if (fabs(xmid - x4) < 3 && fabs(ymid - y4) < 3) {
	    pwVector(round(xmid)+DX, round(ymid)+DY, round(x4)+DX, round(y4)+DY);
	    }
	else {
	    chaikin_spline(xmid, ymid, 
			((x2 + 3*x3) / 4),  ((y2 + 3*y3) / 4),
			((x3 + x4) / 2),  ((y3 + y4) / 2), x4, y4);
	    }
	}
