#include <stdio.h>
#include <xview/xview.h>
#include <sys/stat.h>
#include <errno.h>
#include <xview/notice.h>
#include "tool.h"
#include "g.h"
#include "menu.h"
#include "ext.h"
#include "extxv.h"

store_proc()
{
	init_protocol_name_reader();
	canvas_reader = name_reader;
}

load_proc()
{

	int result;

	result = notice_prompt(canvas, 0,
				NOTICE_MESSAGE_STRINGS, 
					"Have you stored the current graph?", 0,
				NOTICE_BUTTON_NO, "Go ahead with load",
				NOTICE_BUTTON_YES, "Store the current graph",
				0);
	if (result == NOTICE_YES)
		store_proc();
}


init_protocol_name_reader()
{
	strcpy(askname, "Enter the protocol name of the graph : ");
	sprintf(name, "%s", protocol_name);
	nameptr = strlen(name)-1; 
	namelength = NAME_LENGTH;
	sw = READING_PROTOCOL_NAME;
	write_text(askname,name);
}

load_file(filename)
char filename[];
{
	int  	 i, n, j, first, last, in, out, next, nl, ns, nd, nrp, ni;
	int	 type;
	FILE	*fd;
	struct g_node *node;
	struct g_link *link;
	struct g_rspt *rspt;
	struct g_label *label;
	char buf[200];

	/*  open "filename" with write access */

	fd = (FILE *) 0;
	for (i=0; i<3 && fd == (FILE *) 0; i++)
		fd = fopen(filename, "r");
	if (fd == (FILE *) 0) {
		warning("Sorry, couldn't open %s",filename);
		return;
	}
	fscanf(fd, "%d\n", &g1->type);
	if (g1->type != PG) { 
		put_text("It is not a machine graph!"); 
		return; 
	}
	fscanf(fd, "%d %d %d %d\n", &g1->node_no, &g1->link_no, &g1->rspt_no, &g1->label_no);
	g1->node_array = (struct g_node **) malloc(g1->node_no*sizeof(struct g_node *)+1);
	g1->link_array = (struct g_link **) malloc(g1->link_no*sizeof(struct g_link *)+1);
	g1->rspt_array = (struct g_rspt **) malloc(g1->rspt_no*sizeof(struct g_rspt *)+1);
	g1->label_array = (struct g_label **) malloc(g1->label_no*sizeof(struct g_label *)+1);
	*g1->node_array = (struct g_node *) 0;
	for (i = 1; i <= g1->node_no; i++)
		*(g1->node_array+i) = (struct g_node *) malloc(G_NODE_SIZE);
	*g1->link_array = (struct g_link *) 0;
	for (i = 1; i <= g1->link_no; i++)
		*(g1->link_array+i) = (struct g_link *) malloc(G_LINK_SIZE);
	*g1->rspt_array = (struct g_rspt *) 0;
	for (i = 1; i <= g1->rspt_no; i++)
		*(g1->rspt_array+i) = (struct g_rspt *) malloc(G_RSPT_SIZE);
	*g1->label_array = (struct g_label *) 0;
	for (i = 1; i <= g1->label_no; i++)
		*(g1->label_array+i) = (struct g_label *) malloc(G_LABEL_SIZE);
	fscanf(fd, "first_node->no = %d\n", &first);
	g1->first_node = *(g1->node_array+first);
	fscanf(fd, "initial node no. = %d\n", &n);
	g1->initial_node = *(g1->node_array+n);
	for (i = 1; i <= g1->node_no; i++) {
		fscanf(fd, "%d", &n);
		node = *(g1->node_array+n);
		node->no = n;
		fscanf(fd, "%d %d %d %d %d %d %d %d ",
		&node->ssno, &node->x, &node->y, &node->reachable,
		&in, &out, &next, &j);
		if (j != 0) {
			fgets(buf, NAME_LENGTH, fd);
			n = strlen(buf) - 1;
			buf[n] = (char) 0;
		} else {
			n = 1;
			buf[0] = (char) 0;
			}
		node->label = (char *) malloc(n*sizeof(char));
		strcpy(node->label, buf);
		node->inlink = *(g1->link_array+in);
		node->outlink = *(g1->link_array+out);
		node->next = *(g1->node_array+next);
	}

	fscanf(fd, "first_link->no = %d, last_link->no = %d\n", &first, &last);
	g1->first_link = *(g1->link_array+first);
	g1->last_link = *(g1->link_array+last);
	for (i = 1; i <=  g1->link_no; i++) {
		fscanf(fd, "%d ", &n);
		link = *(g1->link_array+n);
		link->no = n;
		fscanf(fd, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",
		&link->type, &link->arcno, &link->channel_type, &link->src_port.x, &link->src_port.y,
		&ns, &link->dst_port.x, &link->dst_port.y, 
		&nd, &nl, &nrp, &in, &out, &next);
		link->src_port.node = *(g1->node_array+ns);
		link->dst_port.node = *(g1->node_array+nd);
		link->label = *(g1->label_array+nl);
		link->rest_points = *(g1->rspt_array+nrp);
		link->inlink = *(g1->link_array+in);
		link->outlink = *(g1->link_array+out);
		link->next = *(g1->link_array+next);
	}
	fscanf(fd, "first_rspt->no = %d\n", &first);
	g1->first_rspt = *(g1->rspt_array+first);
	for (i = 1; i <= g1->rspt_no; i++) {
		fscanf(fd, "%d ", &n);
		rspt = *(g1->rspt_array+n);
		rspt->no = n;
		fscanf(fd, "%d %d %d %d %d\n",
		&rspt->x, &rspt->y, &nl, &ni, &next);
		rspt->link = *(g1->link_array+nl);
		rspt->next_inlink = *(g1->rspt_array+ni);
		rspt->next = *(g1->rspt_array+next);
	}
	fscanf(fd, "first_label->no = %d\n", &first);
	g1->first_label = *(g1->label_array+first);
	for (i = 1; i <= g1->label_no; i++) {
		fscanf(fd, "%d ", &n);
		label = *(g1->label_array+n);
		label->no =n;
		fscanf(fd, "%d %d %d %d %c %d %d %d ",
		&label->x, &label->y, &label->w, &label->h,
		&label->abn, &nl, &next, &j);
		if (j != 0) {
			fgets(buf, LABELNAME_LENGTH, fd);
			n = strlen(buf) - 1;
			buf[n] = (char) 0;
		} else {
			n = 1;
			buf[0] = (char) 0;
			}
		label->name = (char *) malloc(n*sizeof(char));
		strcpy(label->name, buf);
		label->link = *(g1->link_array+nl);
		label->next = *(g1->label_array+next);
	}
	fclose(fd);
	printf("Finish loading %s\n", filename);
	if (mode == LOAD || mode == LOAD_GRAPH) {
		release_objects();
		g->node_no = g1->node_no;
		g->link_no = g1->link_no;
		g->rspt_no = g1->rspt_no;
		g->label_no = g1->label_no;
		g->first_node = g1->first_node;
		g->initial_node = g1->initial_node;
		g->first_link = g1->first_link;
		g->last_link = g1->last_link;
		g->first_rspt = g1->first_rspt;
		g->first_label = g1->first_label;
		}
	else { /* load subgraph from file */
		struct g_node *n;
		struct g_link *l;
		struct g_rspt *r;
		struct g_label *la;

		if (g->node_no == 0) g->initial_node = g1->initial_node;
		for (node = g1->first_node; node != 0; ) {
			node->no = ++(g->node_no);
			node->x += cur_x;
			node->y += cur_y;
			n = node;
			node = node->next;
			insert_node(n);
			}
		for (link = g1->first_link; link != 0; ) {
			link->no = ++(g->link_no);
			link->src_port.x += cur_x;
			link->src_port.y += cur_y;
			link->dst_port.x += cur_x;
			link->dst_port.y += cur_y;
			l = link;
			link = link->next;
			insert_link(l);
			}
		for (rspt = g1->first_rspt; rspt != 0; ) {
			rspt->no = ++(g->rspt_no);
			rspt->x += cur_x;
			rspt->y += cur_y;
			r = rspt;
			rspt = rspt->next;
			insert_rspt(r);
			}
		for (label = g1->first_label; label != 0; ){
			label->no = ++(g->label_no);
			label->x += cur_x;
			label->y += cur_y;
			la = label;
			label = label->next;
			insert_label(la);
			}
		}
	free(g1->node_array);
	free(g1->link_array);
	free(g1->rspt_array);
	free(g1->label_array);
	erase_graph();
	clear_msg();
	strcpy(g->name, process_name);
	DX = g->DX = 300; DY = g->DY = 5;
	draw_graph();
}

save_graph_to_file(g, fd)
struct GRAPH    *g;
FILE            *fd;
{

	short	 i;
	char 	buf1[200];
	int 	*new_node_no, *new_link_no, *new_rspt_no, *new_label_no;

	/*******************************************************
			garbage prevention
		compressing the range of the no field of g_node, g_link,
		g_rspt, g_label.
	*******************************************************/
	new_node_no = (int *) malloc(g->node_no*sizeof(int)+1);
	for (node = g->first_node, i = 1; node != 0; i++, node = node->next) 
		*(new_node_no+node->no) = i;
	g->node_no = i - 1;

	new_link_no = (int *) malloc(g->link_no*sizeof(int)+1);
	for (link = g->first_link, i = 1; link != 0; i++, link = link->next) 
		*(new_link_no+link->no) = i;
	g->link_no = i - 1;

	new_rspt_no = (int *) malloc(g->rspt_no*sizeof(int)+1);
	for (rspt = g->first_rspt, i = 1; rspt != 0; i++, rspt = rspt->next) 
		*(new_rspt_no+rspt->no) = i;
	g->rspt_no = i - 1;

	new_label_no = (int *) malloc(g->label_no*sizeof(int)+1);
	for (label = g->first_label, i = 1; label != 0; i++, label = label->next) 
		*(new_label_no+label->no) = i;
	g->label_no = i - 1;

	fprintf(fd, "%d\n", PG);

	fprintf(fd, "%d %d %d %d\n", g->node_no, g->link_no, g->rspt_no, g->label_no);
	fprintf(stderr, "Save number: %d %d %d %d\n", g->node_no, g->link_no, g->rspt_no, g->label_no);
	fprintf(fd, "first_node->no = %d\n", 
		(g->first_node == (struct g_node *) 0) ? 0 : *(new_node_no+g->first_node->no));
	fprintf(fd, "initial node no. = %d\n", 
		(g->initial_node == (struct g_node *) 0) ? 0 : *(new_node_no+g->initial_node->no));

	for (node = g->first_node; node !=(struct g_node *) 0; node = node->next)
		fprintf(fd, "%d 0 %d %d 0 %d %d %d %d %s\n",
			*(new_node_no+node->no), node->x, node->y, 
			(node->inlink == (struct g_link *) 0) ? 
				0 : *(new_link_no+node->inlink->no), 
			(node->outlink == (struct g_link *) 0) ? 
				0 : *(new_link_no+node->outlink->no), 
			(node->next == (struct g_node *) 0) ? 
				0 : *(new_node_no+node->next->no),
			strlen(node->label),
			node->label);

	fprintf(fd, "first_link->no = %d, last_link->no = %d\n",  
		(g->first_link == (struct g_link *) 0) ? 
			0 : *(new_link_no+g->first_link->no),
		(g->last_link == (struct g_link *) 0) ? 
			0 : *(new_link_no+g->last_link->no));
	for (link = g->first_link; link != (struct g_link *) 0; link = link->next)
		fprintf(fd, "%d %d 0 %d %d %d %d %d %d %d %d %d %d %d %d\n",
			*(new_link_no+link->no), 
			link->type, link->channel_type, 
			link->src_port.x, link->src_port.y,
			*(new_node_no+link->src_port.node->no), 
			link->dst_port.x,  link->dst_port.y, 
			*(new_node_no+link->dst_port.node->no),
			(link->label == (struct g_label *) 0) ? 
				0 : *(new_label_no+link->label->no), 
			(link->rest_points == (struct g_rspt *) 0) ? 
				0 : *(new_rspt_no+link->rest_points->no),
			(link->inlink == (struct g_link *) 0) ? 
				0 : *(new_link_no+link->inlink->no), 
			(link->outlink == (struct g_link *) 0) ? 
				0 : *(new_link_no+link->outlink->no),
			(link->next == (struct g_link *) 0) ? 
				0 : *(new_link_no+link->next->no));
	fprintf(fd, "first_rspt->no = %d\n", 
		(g->first_rspt == (struct g_rspt *) 0) ? 
			0 : *(new_rspt_no+g->first_rspt->no));
	for (rspt = g->first_rspt; rspt != (struct g_rspt *) 0; rspt = rspt->next)
		fprintf(fd,"%d %d %d %d %d %d\n",
			*(new_rspt_no+rspt->no), 
			rspt->x, rspt->y, *(new_link_no+rspt->link->no),
			(rspt->next_inlink == (struct g_rspt *) 0) ? 
				0 : *(new_rspt_no+rspt->next_inlink->no), 
			(rspt->next == (struct g_rspt *) 0) ? 
				0 : *(new_rspt_no+rspt->next->no));

	fprintf(fd, "first_label->no = %d\n",
		(g->first_label == (struct g_label *) 0) ? 
			0 : *(new_label_no+g->first_label->no));
	for (label = g->first_label; label != (struct g_label *) 0; label = label->next)
		fprintf(fd, "%d %d %d %d %d _ %d %d %d %s\n",
			*(new_label_no+label->no), 
			label->x, label->y, label->w, label->h,
			(label->link == (struct g_link *) 0) ? 
				0 : *(new_link_no+label->link->no),
			(label->next == (struct g_label *) 0) ? 
				0 : *(new_label_no+label->next->no),
			strlen(label->name),
			label->name);	 

	/*********   release arrays ************/
	free(new_node_no);
	free(new_link_no);
	free(new_rspt_no);
	free(new_label_no);
	fprintf(fd, "***\n");
}

store_file()
{
	short	 i;
	FILE	*fd;
	char 	buf1[200];

	sprintf(buf1, "%s.%s", protocol_name, process_name);
	fd = fopen(buf1, "w");
	if (fd == (FILE *) 0) {
		warning("Sorry, couldn't open %s", buf1);
		return;
	}
	save_graph_to_file(g, fd);
	fclose(fd);
}

