#include <stdio.h>
#include <xview/xview.h>
#include <sys/stat.h>
#include "tool.h"
#include "g.h"
#include "menu.h"
#include "ext.h"

in_link_list(l)
struct g_link *l;
{
	struct LINK_LIST *ll;

	if (l == 0) return;
	for (ll = link_list; ll != 0; ll = ll->next) 
		if (ll->link == l) return(1);
	return(0);
}

struct g_link *
look_for_inlink(n)
struct g_node *n;
{
	struct g_link *inl;

	for (inl = n->inlink; inl != 0; inl = inl->inlink) 
		if (in_link_list(inl)) return(inl);
	return(0);
}

struct g_link *
look_for_outlink(n)
struct g_node *n;
{
	struct g_link *outl;

	for (outl = n->outlink; outl != 0; outl = outl->outlink) 
		if (in_link_list(outl)) return(outl);
	return(0);
}

struct g_link *
search_for_inlink(l)
struct g_link *l;
{
	struct g_link *inl;

	for (inl = l->inlink; inl != 0; inl = inl->inlink) 
		if (in_link_list(inl)) return(inl);
	return(0);
}

struct g_link *
search_for_outlink(l)
struct g_link *l;
{
	struct g_link *outl;

	for (outl = l->outlink; outl != 0; outl = outl->outlink) 
		if (in_link_list(outl)) return(outl);
	return(0);
}

store_sub_topology()
{
	struct NODE_LIST *nl;
	struct LINK_LIST *ll, *b;
	struct RSPT_LIST *rl;
	struct LABEL_LIST *lal;
	short	 i;
	FILE	*fd;
	char buf1[200];
	int 	*new_node_no, *new_link_no, *new_rspt_no, *new_label_no;
	struct g_link *inl, *outl;


	sprintf(buf1, "%s.%s", protocol_name, process_name);
	fd = fopen(buf1, "w");
	if (fd == 0) {
		warning("Sorry, couldn't open %s", buf1);
		return;
		}
	/*******************************************************
			garbage prevention
		compressing the range of the no field of g_node, g_link,
		g_rspt, g_label.
	*******************************************************/
	new_node_no = (int *) malloc(g->node_no*sizeof(int)+1);
	for (nl = node_list, i = 1; nl != 0; i++, nl = nl->next) 
		*(new_node_no+nl->node->no) = i;
	g1->node_no = i - 1;
	g1->first_node = (node_list == 0) ? 0 : node_list->node;
	g1->initial_node = (in_node_list(initial_node)) ? initial_node : 0;

	new_link_no = (int *) malloc(g->link_no*sizeof(int)+1);
	for (b = ll = link_list, i = 1; ll != 0; i++, b = ll, ll = ll->next) 
		*(new_link_no+ll->link->no) = i;
	g1->link_no = i - 1;
	g1->first_link = (link_list == 0) ? 0 : link_list->link;
	g1->last_link = (b == 0) ? 0 : b->link;

	new_rspt_no = (int *) malloc(g->rspt_no*sizeof(int)+1);
	for (rl = rspt_list, i = 1; rl != 0; i++, rl = rl->next) 
		*(new_rspt_no+rl->rspt->no) = i;
	g1->rspt_no = i - 1;
	g1->first_rspt = (rspt_list == 0) ? 0 : rspt_list->rspt;

	new_label_no = (int *) malloc(g->label_no*sizeof(int)+1);
	for (lal = label_list, i = 1; lal != 0; i++, lal = lal->next) 
		*(new_label_no+lal->label->no) = i;
	g1->label_no = i - 1;
	g1->first_label = (label_list == 0) ? 0 : label_list->label;

	fprintf(fd, "%d\n", PG);

	fprintf(fd, "%d %d %d %d\n", g1->node_no, g1->link_no, g1->rspt_no, g1->label_no);
	fprintf(fd, "first_node->no = %d\n", 
		(g1->first_node == (struct g_node *) 0) ? 0 : *(new_node_no+g1->first_node->no));
	fprintf(fd, "initial node no. = %d\n", 
		(g1->initial_node == (struct g_node *) 0) ? 0 : *(new_node_no+g1->initial_node->no));

	for (nl = node_list; nl != 0; nl = nl->next) {
		node = nl->node;
		fprintf(fd, "%d 0 %d %d 0 ",
			*(new_node_no+node->no), node->x, node->y);
		inl = look_for_inlink(node);
		outl = look_for_outlink(node);
		fprintf(fd, "%d %d %d %d %s\n",
			(inl == (struct g_link *) 0) ? 
				0 : *(new_link_no+inl->no), 
			(outl == (struct g_link *) 0) ? 
				0 : *(new_link_no+outl->no), 
			(nl->next == (struct NODE_LIST *) 0) ? 
				0 : *(new_node_no+nl->next->node->no),
			strlen(node->label),
			node->label);
		}

	fprintf(fd, "first_link->no = %d, last_link->no = %d\n",  
		(g1->first_link == (struct g_link *) 0) ? 
			0 : *(new_link_no+g1->first_link->no),
		(g1->last_link == (struct g_link *) 0) ? 
			0 : *(new_link_no+g1->last_link->no));
	for (ll = link_list; ll != 0; ll = ll->next) {
		link = ll->link;
		fprintf(fd, "%d %d 0 %d %d %d %d %d %d %d %d %d ",
			*(new_link_no+link->no), 
			link->type, link->channel_type, 
			link->src_port.x, link->src_port.y,
			*(new_node_no+link->src_port.node->no), 
			link->dst_port.x,  link->dst_port.y, 
			*(new_node_no+link->dst_port.node->no),
			(link->label == (struct g_label *) 0) ? 
				0 : *(new_label_no+link->label->no), 
			(link->rest_points == (struct g_rspt *) 0) ? 
				0 : *(new_rspt_no+link->rest_points->no));
		inl = search_for_inlink(link);
		outl = search_for_outlink(link);
		fprintf(fd, "%d %d %d\n",
			(inl == (struct g_link *) 0) ? 
				0 : *(new_link_no+inl->no), 
			(outl == (struct g_link *) 0) ? 
				0 : *(new_link_no+outl->no),
			(ll->next == (struct LINK_LIST *) 0) ? 
				0 : *(new_link_no+ll->next->link->no));
		}
	fprintf(fd, "first_rspt->no = %d\n", 
		(g1->first_rspt == (struct g_rspt *) 0) ? 
			0 : *(new_rspt_no+g1->first_rspt->no));
	for (rl = rspt_list; rl != 0; rl = rl->next) {
		rspt = rl->rspt;
		fprintf(fd,"%d %d %d %d %d %d\n",
			*(new_rspt_no+rspt->no), 
			rspt->x, rspt->y, *(new_link_no+rspt->link->no),
			(rspt->next_inlink == (struct g_rspt *) 0) ? 
				0 : *(new_rspt_no+rspt->next_inlink->no), 
			(rl->next == (struct RSPT_LIST *) 0) ? 
				0 : *(new_rspt_no+rl->next->rspt->no));

		}
	fprintf(fd, "first_label->no = %d\n",
		(g1->first_label == (struct g_label *) 0) ? 
			0 : *(new_label_no+g1->first_label->no));
	for (lal = label_list; lal != 0; lal = lal->next) {
		label = lal->label;
		fprintf(fd, "%d %d %d %d %d _ %d %d %d %s\n",
			*(new_label_no+label->no), 
			label->x, label->y, label->w, label->h,
			(label->link == (struct g_link *) 0) ? 
				0 : *(new_link_no+label->link->no),
			(lal->next == (struct LABEL_LIST *) 0) ? 
				0 : *(new_label_no+lal->next->label->no),
			strlen(label->name),
			label->name);	 

		}
	/*********   release arrays ************/
	free(new_node_no);
	free(new_link_no);
	free(new_rspt_no);
	free(new_label_no);
	fprintf(fd, "***\n");
	fclose(fd);
	return;
}

	

