#include <stdio.h>
#include <xview/xview.h>
#include <math.h>
#include "tool.h"
#include "g.h"

#define                          round(x)               ((int) (x + .5))

extern int               DX, DY;

op_spline_with_tension(link, dore, n)
struct g_link   *link;
int              dore; /*draw or erase */
int	 n;
{
	struct g_rspt   *p;
	double	d, t, x[200], y[200], slp1, slpn, xp[200], yp[200], temp[200], s[200], tension;
	int islpsw, ierr;
	int i, ixs, iys, oldxs, oldys;
	double xs, ys, length;

	/* initialize x and y arrays */
	x[1] = (double) link->src_port.x;
	y[1] = (double) link->src_port.y;
	x[n] = (double) link->dst_port.x;
	y[n] = (double) link->dst_port.y;
	for (i = 2, p = link->rest_points; p != NULL; p = p->next_inlink, i++) {
		x[i] = (double) p->x;
		y[i] = (double) p->y;
		}
	tension = 5.;
	kurv1(n, x, y, slp1, slpn, 3, xp, yp, temp, s, tension, ierr);
	length = s[n];
	length = (length > 10.0*n) ? 10.0*n : length;
	d = 1.0/length;
	oldxs = (int) x[1];
	oldys = (int) y[1];
	for (t = d; t < 1.0; t += d) {
		kurv2(t, &xs, &ys, n, x, y, xp, yp, s, tension);
		ixs = (int) xs;
		iys = (int) ys;
		if ((oldxs == ixs) && (oldys == iys)) continue;
		if (dore == DRAW) draw_vector(oldxs+DX, oldys+DY, ixs+DX, iys+DY);
		else erase_vector(oldxs+DX, oldys+DY, ixs+DX, iys+DY);
		oldxs = ixs;
		oldys = iys;
		}
	op_arrow_head((int)x[n-1], (int)y[n-1], (int)x[n], (int)y[n], dore);
}
	

op_t_spline(link, dore)
struct g_link   *link;
int 		 dore; /*draw or erase */
{
	struct g_rspt   *p;
	long int n;

	if (link->rest_points == NULL) {
	   op_arc(link->src_port.x, link->src_port.y, link->dst_port.x,
		link->dst_port.y, dore);
		return;
		}
	/* calculate the no. of intermediate points in this link */
	for (p = link->rest_points, n = 2; p != NULL; n++, p = p->next_inlink);
	op_spline_with_tension(link, dore, n);
}
